# ###################   Sequencer State Machine   ###########################################
proc find_start_stop_time_of_states_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT clock    
	set current_SEQ_state 0
	set new_SEQ_state 0
	set current_KR_state 0
	set new_KR_state 0
	
	#Clearing the list of *_occurence variables for all  KR states (Initialize, AN, LT, Data)
	for {set m 0} {$m < [llength [dict get $MAIN_DICT var.no_of_KRstates]]} {incr m}	{
		dict set MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] $m]_occurence ""
	}
	
	dict set MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED 0
	for {set j 0} {$j <= [dict get $MAIN_DICT var.TOTAL_SAMPLES]} {incr j}	{
		for {set i 1} {$i <= [dict get $MAIN_DICT var.TOTAL_STATES]} {incr i}	{
			set state_is_active [dict get $MAIN_DICT [dict get $MAIN_DICT var.signal$i].[expr {$j}]]
			if {$state_is_active == "1"} {
				set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$j}]] %x]
				set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$j}]] %x]
				set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$j}]] %x]
				set new_SEQ_state [dict get $MAIN_DICT var.signal$i]
				if {$current_SEQ_state != $new_SEQ_state} {
					dict incr MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED 
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED] [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].[dict get $MAIN_DICT var.signal$i]
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].startSample $j
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].stopSample $j
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].startTime [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].stopTime [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].display 1
					
					for {set m 0} {$m < [llength [dict get $MAIN_DICT var.no_of_KRstates]]} {incr m}	{	
						if {[lsearch [dict get $MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] $m]] $new_SEQ_state] != -1} {
							set new_KR_state [lindex [dict get $MAIN_DICT var.no_of_KRstates] $m]
							if {$current_KR_state != $new_KR_state} {
								dict incr MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED
								dict lappend MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] $m]_occurence "[dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED].$new_KR_state"
								dict set MAIN_DICT KR_states_seq.[dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED] "[dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED].$new_KR_state"
							}
							dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].KRstate "[dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED].$new_KR_state"
							dict lappend MAIN_DICT KR_states_seq.[dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED].$new_KR_state [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]
						}
					}
					set current_SEQ_state $new_SEQ_state
					set current_KR_state $new_KR_state
				} else {
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].stopSample $j
					dict set MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED].stopTime [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]				
				}
			} 
		}
	}
	toggle_check SSM_AN_ABL SSM_AN_CHK SSM_RC_LT
	#Smart Messages 
	dict set MAIN_DICT var.SeqSM_Message ""
	set state1 "SignalTap capture ended in 100G Mode. 
				\nLink is found to be unstable (device repetitively trying LINK UP). Most likely device is failing a certain state and hence repeating the link up sequence.
				\nPlease make sure to run STP for a longer duration (~5sec) to confirm if device is stable in 100G (LINK UP) or always just tries to LINK UP"
									
	set state2 "SignalTap capture ended in 100G Mode. 
				\nLink is found to be stable (device NOT repetitively trying LINK UP). 
				\nPlease make sure to run STP for a longer duration (~5sec) to confirm if device is stable in 100G mode (LINK UP) or if it fails anytime going forward."																								
									
	set state3 "SignalTap capture DID NOT end in 100G Mode. 
				\nLink is found to be unstable (device repetitively trying LINK UP). Most likely device is failing a certain state and hence repeating the link up sequence.
				\nPlease make sure to run STP for a longer duration (~5sec) to check if device achieves LINK UP or it is still unstable"
	
	set state4 "SignalTap capture DID NOT end in 100G Mode. 
				\nLink is found to be unstable (device NOT repetitively trying LINK UP). 
				\n Remote Device may not be the same technology as the local device."
				
	set state5 "SignalTap capture DID NOT end in 100G Mode. 
				\nLink is found to be stable (device NOT repetitively trying LINK UP). 
				\nAs the device states look stable (NOT repeating) and device did not end in 100G mode, most likely STP is NOT captured for long enough. 
				\nPlease make sure to run STP for a longer duration (~5sec)"

	set state6 "Detailed messages are displayed if at least 3 device SSM states are captured."
									
									
	if {[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED] >= 3} {
		if {[regexp "SSM_LNK_RDY" [dict get $MAIN_DICT states_seq.[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]] match]}  {
			if {[regexp "SSM_LNK_CHK" [dict get $MAIN_DICT states_seq.[expr {[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]-1}]] match]} {
				if {[llength [dict get $MAIN_DICT var.SEQ_Initialize_occurence]] >= 2} {
					dict set MAIN_DICT var.SeqSM_Message $state1
				} else {
					dict set MAIN_DICT var.SeqSM_Message $state2
				}
			} 
		} else {
			if {[llength [dict get $MAIN_DICT var.SEQ_Initialize_occurence]] >= 2} {
				dict set MAIN_DICT var.SeqSM_Message $state3
			} else {
			if {[dict get $MAIN_DICT toggle_true] == 1} { 
				dict set MAIN_DICT var.SeqSM_Message $state4
			} else {
			dict set MAIN_DICT var.SeqSM_Message $state5
			}
			}
		}
	} else {
		dict set MAIN_DICT var.SeqSM_Message $state6
	}
	
	#DEBUG
	puts ""
	puts "Total KR states occurences: [dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED]"
	puts "Total SEQ states occurences: [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]"
	puts "SEQ_Init occurences: [dict get $MAIN_DICT var.SEQ_Initialize_occurence]"
	puts "AN occurences: [dict get $MAIN_DICT var.Auto_Neg_occurence]"
	puts "LT occurences: [dict get $MAIN_DICT var.Link_Training_occurence]"
	puts "DATA occurences: [dict get $MAIN_DICT var.Data_occurence]"
	puts ""
	for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{
		puts "[dict get $MAIN_DICT states_seq.[expr {$j}]], startSample: [dict get $MAIN_DICT states_seq.[expr {$j}].startSample], stopSample: [dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]"
	}
}

proc GUI_Sequencer_SM_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock 
	global hierarchy5_ch0 hierarchy5_ch1 hierarchy5_ch2 hierarchy5_ch3
	global hierarchy6
	
	dashboard_remove $dash my_tabs
	
	#"my_tabs" is a tabbedgroup. Whatever is added directly to "mytabs" will be a new tab in main page of tool.
	dashboard_add $dash my_tabs tabbedGroup main_group
	dict set MAIN_DICT var.my_tabs_exists 1
	
	widget_group 1 sequencer_SM_tab my_tabs 2 "Sequencer State Machine"
	
	#widget_group 1 link_status sequencer_SM_tab 999 "Link Status"
		#widget_led 1 "link_status_led_1G" link_status "1G Link" [dict get $MAIN_DICT var.SeqSM_link_status_led_1G]
		#widget_led 1 "link_status_led_10G" link_status "10G Link" [dict get $MAIN_DICT var.SeqSM_link_status_led_10G]
	
	widget_group 1 state_transition_diagram sequencer_SM_tab 1 "State Transition Diagram"
		widget_label 1 display_LF_timer_clock  state_transition_diagram  "Assumed Reference Timer Clock = [expr {$clock/1000}]MHz"  black
		
		widget_group 1 column_header state_transition_diagram 5 ""
			widget_label 1 States_label_dummy  column_header  ""  black
				dashboard_set_property $dash States_label_dummy preferredWidth 75
			widget_label 1 States_label  column_header  "States"  black
				dashboard_set_property $dash States_label preferredWidth 90
			widget_label 1 Start_label  column_header  "Start (msec)"  black
				dashboard_set_property $dash Start_label preferredWidth 100
			widget_label 1 Stop_label  column_header  "Stop (msec)"  black
				dashboard_set_property $dash Stop_label preferredWidth 100
			widget_label 1 Delta_label  column_header  "Delta (msec)"  black
				dashboard_set_property $dash Delta_label preferredWidth 100
		
	for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED]} {incr j}	{	
		#set abc [dict get $MAIN_DICT KR_states_seq.[dict get $MAIN_DICT KR_states_seq.[expr {$j}]]]
		widget_group 1 [dict get $MAIN_DICT KR_states_seq.[expr {$j}]] state_transition_diagram 4 [dict get $MAIN_DICT KR_states_seq.[expr {$j}]]
	}
	
	for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{
			if {[regexp "SSM_AN_CHK" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT an_done.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} {
				dict set MAIN_DICT var.seq_state_color red 
			} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT [set hierarchy5_ch0]rx_trained.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} { 
				dict set MAIN_DICT var.seq_state_color red 
			} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT [set hierarchy5_ch1]rx_trained.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} { 
				dict set MAIN_DICT var.seq_state_color red 
			} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT [set hierarchy5_ch2]rx_trained.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} { 
				dict set MAIN_DICT var.seq_state_color red 
			} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT [set hierarchy5_ch3]rx_trained.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} { 
				dict set MAIN_DICT var.seq_state_color red 
			} elseif {[regexp "SSM_LNK_CHK" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT deskew_locked.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} {
						dict set MAIN_DICT var.seq_state_color red 
			} elseif {[regexp "SSM_LNK_RDY" [dict get $MAIN_DICT states_seq.[expr {$j}]] match] && [dict get $MAIN_DICT align_locked.[dict get $MAIN_DICT states_seq.[expr {$j}].stopSample]]==0} {
				dict set MAIN_DICT var.seq_state_color red 
			} else {
				dict set MAIN_DICT var.seq_state_color green
			}
		
		if {[dict get $MAIN_DICT states_seq.[expr {$j}].display] == 1} {
		widget_button 1 [dict get $MAIN_DICT states_seq.[expr {$j}]] [dict get $MAIN_DICT states_seq.[expr {$j}].KRstate] "[dict get $MAIN_DICT states_seq.[expr {$j}]]" "false" [dict get $MAIN_DICT var.seq_state_color] "black" 175 ""
	
		widget_label 1 [dict get $MAIN_DICT states_seq.[expr {$j}]]_start [dict get $MAIN_DICT states_seq.[expr {$j}].KRstate] "[format %.3f [dict get $MAIN_DICT states_seq.[expr {$j}].startTime]]" "black"
			dashboard_set_property $dash [dict get $MAIN_DICT states_seq.[expr {$j}]]_start preferredWidth 100
			
		widget_label 1 [dict get $MAIN_DICT states_seq.[expr {$j}]]_stop [dict get $MAIN_DICT states_seq.[expr {$j}].KRstate] "[format %.3f [dict get $MAIN_DICT states_seq.[expr {$j}].stopTime]]" "black"
			dashboard_set_property $dash [dict get $MAIN_DICT states_seq.[expr {$j}]]_stop preferredWidth 100
			
		widget_label 1 [dict get $MAIN_DICT states_seq.[expr {$j}]]_delta [dict get $MAIN_DICT states_seq.[expr {$j}].KRstate] "[format %.3f [expr {[dict get $MAIN_DICT states_seq.[expr {$j}].stopTime] - [dict get $MAIN_DICT states_seq.[expr {$j}].startTime]}]]" "blue"
			dashboard_set_property $dash [dict get $MAIN_DICT states_seq.[expr {$j}]]_delta preferredWidth 100
			}
	}
	
	dict set MAIN_DICT var.tabsDummyHeight [expr {1200+([expr {[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]}]*10)}]
	dict set MAIN_DICT var.unwantedGroupDummyHeight [expr {[expr {[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]-[dict get $MAIN_DICT count_toggle]}]*44}]
	
	widget_text 1 message_window sequencer_SM_tab false "**IMPORTANT MESSAGES**\n[dict get $MAIN_DICT var.SeqSM_Message]" [dict get $MAIN_DICT var.unwantedGroupDummyHeight] 600
		
	widget_group 1 unwanted_just_to_anchor_SSM sequencer_SM_tab 1 ""	
		dashboard_set_property $dash unwanted_just_to_anchor_SSM preferredHeight [expr {1425 - [dict get $MAIN_DICT var.unwantedGroupDummyHeight]}]
}



# ###################   AN   ###########################################
proc AN_datamining_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock    
	
	puts "\nAN Datamining in progress..."
	#Below FOR loop is for no. of AN occurences 
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
		dict set MAIN_DICT var.SEQstates_perAN[set j] [dict get $MAIN_DICT KR_states_seq.[lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]]
		
		#Processing for AN_ENABLE. Checking the status of an_enable at the stop sample of AN (that will most likely be SSM_RC_AN except when the STP capture started somewhere in between the AN). an_enable can be 0 at start of SSM_RC_AN but it eventually is assereted high by the end of SSM_RC_AN. and hence end of SSM_RC_AN is considered below.
			set AN_startsample [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] 0].stopSample]
			if {[dict get $MAIN_DICT an_enable.$AN_startsample] == 1} {
				dict set MAIN_DICT var.AN$j.an_enable_led_color green
			} else {
				dict set MAIN_DICT var.AN$j.an_enable_led_color red
			}
			dict set MAIN_DICT var.AN$j.an_enable_led_text "AN_Enable"
			
		#Processing for LCL_TECH. Checking the status of lcl_tech at the start sample of AN (that will most likely be SSM_RC_AN except when the STP capture started somewhere in between the AN)
			dict set MAIN_DICT var.AN$j.lcl_tech_text_content ""
			set AN_startsample [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] 0].startSample]
			set lcl_tech_value [scan [dict get $MAIN_DICT lcl_tech.$AN_startsample] %x]
			#Below FOR loop is for AN mapping table. We check every bit w.r.t AN mapping table to see the list of supported AN technology
			for {set i 0} {$i < 10} {incr i} {
				set temp_lcl_tech_value [expr {[expr {$lcl_tech_value & [expr {2**$i}]}] >> $i }]
				
				if {$temp_lcl_tech_value == 1} {
					dict append MAIN_DICT var.AN$j.lcl_tech_text_content "[dict get $MAIN_DICT AN_tech_map.[expr {$i+1}]]\n"
				}
			}
				

		#Processing for Remote Device technology (LP_TECH)	
			set new_lp_tech ""
			set current_lp_tech ""
			dict append MAIN_DICT var.AN$j.lp_tech_text_content ""
			#Below FOR loop is for no. of SEQUENCER SM STATES in a particular AN occurence
			for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr k} {	
				set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $k]]   
				
				#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
				for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].stopSample]} {incr i}	{	
					set new_lp_tech [scan [dict get $MAIN_DICT lp_tech.$i] %x]
					#puts "LP Tech being read $j: $new_lp_tech"
					if {$new_lp_tech != $current_lp_tech} {
						if {$new_lp_tech == 0} {
							dict set MAIN_DICT var.AN$j.lp_tech_label_text "Remote Device AN Technology NOT received"
							dict set MAIN_DICT var.AN$j.lp_tech_text_content ""
							#Below FOR loop is for AN mapping table. We check every bit w.r.t AN mapping table to see the list of supported AN technology
							for {set m 0} {$m < 10} {incr m} {
								set temp_new_lp_tech [expr {[expr {$new_lp_tech & [expr {2**$m}]}] >> $m }]								
								if {$temp_new_lp_tech == 1} {
									dict append MAIN_DICT var.AN$j.lp_tech_text_content "[dict get $MAIN_DICT AN_tech_map.[expr {$m+1}]]\n"
								}
							}							
						} else {
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							dict set MAIN_DICT var.AN$j.lp_tech_received_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							
							#dict set MAIN_DICT var.AN$j.lp_tech_label_text "Remote Device AN Technology received at \[[dict get $MAIN_DICT var.AN$j.lp_tech_received_at] ($current_seq_state)\]"
							dict set MAIN_DICT var.AN$j.lp_tech_label_text "Remote Device AN Technology"
							#Below FOR loop is for AN mapping table. We check every bit w.r.t AN mapping table to see the list of supported AN technology
							for {set m 0} {$m < 10} {incr m} {
								set temp_new_lp_tech [expr {[expr {$new_lp_tech & [expr {2**$m}]}] >> $m }]								
								if {$temp_new_lp_tech == 1} {
									dict append MAIN_DICT var.AN$j.lp_tech_text_content "[dict get $MAIN_DICT AN_tech_map.[expr {$m+1}]]\n"
								}
							}
						}
						set current_lp_tech $new_lp_tech
					}
				}	
			}
			puts "LP AN$j Tech: [dict get $MAIN_DICT var.AN$j.lp_tech_text_content]"
			
		#Processing for AN_DONE	
			set new_an_done ""
			set current_an_done ""
			#Below FOR loop is for no. of SEQUENCER SM STATES in a particular AN MODE
			for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr k} {	
				set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $k]]   
			
				#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
				for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].stopSample]} {incr i}	{
					set new_an_done [dict get $MAIN_DICT an_done.$i]
					if {$new_an_done != $current_an_done} {
						#if {![string match $new_an_done $current_an_done]} 
						if {$new_an_done == 0} {
							dict set MAIN_DICT var.AN$j.an_done_led_color red
							dict set MAIN_DICT var.AN$j.an_done_led_text "AN Done"
						} elseif {$new_an_done == 1} {
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							dict set MAIN_DICT var.AN$j.an_done_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							
							dict set MAIN_DICT var.AN$j.an_done_led_color green
							dict set MAIN_DICT var.AN$j.an_done_led_text "AN Done \[[dict get $MAIN_DICT var.AN$j.an_done_asserted_at] ($current_seq_state)\]"
						}
						set current_an_done $new_an_done
					}
				}
			}	
			
			
		#Processing for ackm_wd (AN packet received by local)
		set new_ackm_wd ""
		set current_ackm_wd ""
		set page_type "Base Page"
		set track_toggling_of_bit11 0
		set toggle_bit11 0
		set nxt_pge_no 1
		dict set MAIN_DICT var.AN[set j]_ackm_wd_seqno 1
		#Below FOR loop is for no. of SEQUENCER SM STATES in a particular AN MODE
		for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr k} {	
			set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $k]]
			#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
			for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].stopSample]} {incr i}	{
				set new_ackm_wd [lindex [dict get $MAIN_DICT ackm_wd.$i] 0]
				if {$new_ackm_wd != $current_ackm_wd} {
					set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
					set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
					set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
					set ackm_wd_start_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
					dict set MAIN_DICT var.AN[set j]_ackm_wd_seq.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno]   "0x$new_ackm_wd"
					dict set MAIN_DICT var.AN[set j]_ackm_wd_seq.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno].startTime "$ackm_wd_start_at  ($current_seq_state)"
					
					if {$track_toggling_of_bit11 == 1 && $new_ackm_wd != 0} {
						set new_toggle_bit11 [expr {[expr {"0x$new_ackm_wd" & 0x0800}]  >> 11}]
						if {$new_toggle_bit11 != $toggle_bit11} {
							set page_type "Next Page$nxt_pge_no"
							incr nxt_pge_no
						}
					}		
					
					if {[regexp "Base Page" $page_type match]} {
						set page_type_display $page_type
						if {$new_ackm_wd == 0} {
							set page_type_display ""
						}								
						#set FECbits 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0xC00000000000}]  >> 46}]]
						set AN_Tech 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x3FE00000}]  >> 21}]]
						set Transmitted_Nonce 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x1F0000}]  >> 16}]]
						set Next_Page 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x8000}]  >> 15}]]
						set Ack 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x4000}]  >> 14}]]
						set Remote_Fault 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x2000}]  >> 13}]]
						set Pause_Abi 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x1C00}]  >> 10}]]
						set Echoed_Nonce 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x3E0}]  >> 5}]]						
						set Selector_Field 0x[format %x [expr {"0x$new_ackm_wd" & 0x1F}]]
						set toggle_bit11 [expr {[expr {"0x$new_ackm_wd" & 0x0800}]  >> 11}]
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "$page_type_display"
						#dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\n\nFEC\[47:46]      = $FECbits"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nAN_Tech\[29:21]  = $AN_Tech"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nTX_Nonce\[20:16]  = $Transmitted_Nonce"				
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nNext_Page\[15]   = $Next_Page"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nAck\[14]         = $Ack"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nRemote_Fault\[13] = $Remote_Fault"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nPause_Ability\[12:10]= $Pause_Abi"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nEchoed_Nonce\[9:5] = $Echoed_Nonce"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nSelector_Field\[4:0] = $Selector_Field"					
					} elseif {[regexp "Next Page" $page_type match]} {
						set page_type_display $page_type
						if {$new_ackm_wd == 0} {
							set page_type_display ""
						}
						set DataU 0x[format %x [scan [expr {[expr {"0x$new_ackm_wd" & 0xFFFFFFFF0000}]  >> 16}] %x]]
						set Next_page 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x8000}]  >> 15}]]
						set Ack 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x4000}]  >> 14}]]
						set Message 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x2000}]  >> 13}]]
						set Ack2 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x1000}]  >> 12}]]
						set Toggle 0x[format %x [expr {[expr {"0x$new_ackm_wd" & 0x800}]  >> 11}]]
						set DataL 0x[format %x [expr {"0x$new_ackm_wd" & 0x7FF}]]
						set toggle_bit11 [expr {[expr {"0x$new_ackm_wd" & 0x0800}]  >> 11}]
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "$page_type_display"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\n\nData\[47:16] = $DataU"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nNext Page\[15]  = $Next_page"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nAck\[14]   	= $Ack"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nMessage\[13]   = $Message"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nAck2\[12] = $Ack2"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nToggle\[11]= $Toggle"
						dict append MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] "\nData\[10:0] = $DataL"					
					}
					
					dict incr MAIN_DICT var.AN[set j]_ackm_wd_seqno
					set current_ackm_wd $new_ackm_wd
					
					if {$Ack} {
						set track_toggling_of_bit11 1
					} else {
						set track_toggling_of_bit11 0
					}
				}
			}
		}
#Processing for Final AN Technology (e25_mode, ieee_mode)
			
			set new_ieee_mode ""
			set current_ieee_mode ""
			
			dict set MAIN_DICT AN$j.fnl_tech_decided_at "xxx"
			dict append MAIN_DICT var.AN$j.fnl_tech_text_content ""
			dict set MAIN_DICT var.AN$j.fnl_tech_label_text "Final AN Technology"
			#Below FOR loop is for no. of SEQUENCER SM STATES in a particular AN MODE
			for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr k} {	
				set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $k]]   
			
				#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
				for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].stopSample]} {incr i}	{			
					set new_ieee_mode [scan [dict get $MAIN_DICT ieee_mode.[expr {$i}]] %x ]
					
					if {($new_ieee_mode != $current_ieee_mode )} {
						if {$new_ieee_mode} {
							
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							dict set MAIN_DICT var.AN$j.fnl_tech_decided_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							#dict set MAIN_DICT var.AN$j.fnl_tech_label_text "Final AN Technology decided at \[[dict get $MAIN_DICT var.AN$j.fnl_tech_decided_at] ($current_seq_state)\]"
							dict set MAIN_DICT var.AN$j.fnl_tech_label_text "Final AN Technology decided by local device"
							#Below FOR loop is for AN mapping table. We check every bit w.r.t AN mapping table to see the list of supported AN technology 
							for {set m 0} {$m < 10} {incr m} {
								set temp_final_tech [expr {[expr {$new_ieee_mode & [expr {2**$m}]}] >> $m }]								
								if {$temp_final_tech == 1} {
									dict append MAIN_DICT var.AN$j.fnl_tech_text_content "[dict get $MAIN_DICT AN_tech_map.[expr {$m+1}]]\n"
								}
							}				
						} elseif {($new_ieee_mode==0)} {
							
							dict set MAIN_DICT var.AN$j.fnl_tech_label_text "Final AN Technology NOT decided "
							dict set MAIN_DICT var.AN$j.fnl_tech_text_content ""
							#Below FOR loop is for AN mapping table. We check every bit w.r.t AN mapping table to see the list of supported AN technology
							for {set m 0} {$m < 10} {incr m} {
								set temp_final_tech [expr {[expr {$new_ieee_mode & [expr {2**$m}]}] >> $m }]								
								if {$temp_final_tech == 1} {
									dict append MAIN_DICT var.AN$j.fnl_tech_text_content "[dict get $MAIN_DICT AN_tech_map.[expr {$m+1}]]\n"
								}
							}
						}
						set current_ieee_mode $new_ieee_mode

					}
				}
			}				
		
		#Processing for page_data (AN packet sent by local)
		set new_page_data ""
		set current_page_data  ""
		set page_type "Base Page"
		set track_toggling_of_bit11 0
		set toggle_bit11 0
		set nxt_pge_no 1
		dict set MAIN_DICT var.AN[set j]_page_data_seqno 1
		#Below FOR loop is for no. of SEQUENCER SM STATES in a particular AN MODE
		for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr k} {	
			set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $k]]
			#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
			for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN$j] $k].stopSample]} {incr i}	{
				#set new_page_data [format %.12x [expr {"0x[lindex [dict get $MAIN_DICT page_data.$i] 0]" & 0xFFFFFFFFFFFF}]]
				set new_page_data [string toupper [and_13hex [lindex [dict get $MAIN_DICT page_data.$i] 0]]]
				if {$new_page_data != $current_page_data} {
					set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
					set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
					set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
					set page_data_start_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
					dict set MAIN_DICT var.AN[set j]_page_data_seq.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno]    "0x$new_page_data"
					dict set MAIN_DICT var.AN[set j]_page_data_seq.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno].startTime "$page_data_start_at  ($current_seq_state)"
				
					if {$track_toggling_of_bit11 == 1 && $new_page_data != 0} {
						set new_toggle_bit11 [expr {[expr {"0x$new_page_data" & 0x0800}]  >> 11}]
						if {$new_toggle_bit11 != $toggle_bit11} {
							set page_type "Next Page$nxt_pge_no"
							incr nxt_pge_no
						}
					}
					
					if {[regexp "Base Page" $page_type match]} {
						set page_type_display $page_type
						if {$new_page_data == 0} {
							set page_type_display ""
						}
						#set FECbits 0x[format %x [expr {[expr {"0x$new_page_data" & 0xC00000000000}]  >> 46}]]
						set AN_Tech 0x[format %x [expr {[expr {"0x$new_page_data" & 0x3FE00000}]  >> 21}]]
						set Transmitted_Nonce 0x[format %x [expr {[expr {"0x$new_page_data" & 0x1F0000}]  >> 16}]]
						set Next_Page 0x[format %x [expr {[expr {"0x$new_page_data" & 0x8000}]  >> 15}]]
						set Ack 0x[format %x [expr {[expr {"0x$new_page_data" & 0x4000}]  >> 14}]]
						set Remote_Fault 0x[format %x [expr {[expr {"0x$new_page_data" & 0x2000}]  >> 13}]]
						set Pause_Abi 0x[format %x [expr {[expr {"0x$new_page_data" & 0x1C00}]  >> 10}]]
						set Echoed_Nonce 0x[format %x [expr {[expr {"0x$new_page_data" & 0x3E0}]  >> 5}]]						
						set Selector_Field 0x[format %x [expr {"0x$new_page_data" & 0x1F}]]
						set toggle_bit11 [expr {[expr {"0x$new_page_data" & 0x0800}]  >> 11}]
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "$page_type_display"
						#dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\n\nFEC\[47:46]      = $FECbits"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nAN_Tech\[29:21]  = $AN_Tech"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nTX_Nonce\[20:16]  = $Transmitted_Nonce"							
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nNext_Page\[15]   = $Next_Page"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nAck\[14]         = $Ack"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nRemote_Fault\[13] = $Remote_Fault"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nPause_Ability\[12:10]= $Pause_Abi"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nEchoed_Nonce\[9:5] = $Echoed_Nonce"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nSelector_Field\[4:0] = $Selector_Field"
					} elseif {[regexp "Next Page" $page_type match]} {
						set page_type_display $page_type
						if {$new_page_data == 0} {
							set page_type_display ""
						}
						set DataU 0x[format %x [expr {[expr {"0x$new_page_data" & 0xFFFFFFFF0000}]  >> 16}]]
						set Next_page 0x[format %x [expr {[expr {"0x$new_page_data" & 0x8000}]  >> 15}]]
						set Ack 0x[format %x [expr {[expr {"0x$new_page_data" & 0x4000}]  >> 14}]]
						set Message 0x[format %x [expr {[expr {"0x$new_page_data" & 0x2000}]  >> 13}]]
						set Ack2 0x[format %x [expr {[expr {"0x$new_page_data" & 0x1000}]  >> 12}]]
						set Toggle 0x[format %x [expr {[expr {"0x$new_page_data" & 0x800}]  >> 11}]]
						set DataL 0x[format %x [expr {"0x$new_page_data" & 0x7FF}]]
						set toggle_bit11 [expr {[expr {"0x$new_page_data" & 0x0800}]  >> 11}]
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "$page_type_display"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\n\nData\[47:16] = $DataU"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nNext Page\[15]  = $Next_page"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nAck\[14]   	= $Ack"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nMessage\[13]   = $Message"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nAck2\[12] = $Ack2"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nToggle\[11]= $Toggle"
						dict append MAIN_DICT var.AN[set j]_page_data_packet_breakout.[dict get $MAIN_DICT var.AN[set j]_page_data_seqno] "\nData\[10:0] = $DataL"					
					}
					
					dict incr MAIN_DICT var.AN[set j]_page_data_seqno
					set current_page_data $new_page_data
					
					if {$Ack} {
						set track_toggling_of_bit11 1
					} else {
						set track_toggling_of_bit11 0
					}
				}
			}
		}
		puts "List of SEQ States per AN occurence(SEQstates_perAN$j) =[dict get $MAIN_DICT var.SEQstates_perAN$j]"	
	}
	puts "AN Datamining completed"
}

proc GUI_AN_init_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock 
	
	#Creating one tab for AN mode. It will contain sub tabs for all AN MODE occurences. Whatever is added to the "mytabs" will appear as a separarte tab in main tool. Here "Auto Neg" will be a tab	
	widget_group 1 auto_neg_tab my_tabs 1 "Auto Neg"
	
	#Creating another tabbed_group "AN_subtabs" within "Auto neg". Whatever will be added directly to "AN_subtabs" will appear as a separate tab within "Auto Neg"
	dashboard_add $dash AN_subtabs tabbedGroup auto_neg_tab
		#dashboard_set_property $dash AN_subtabs preferredHeight 1300
		
	puts ""	
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
		widget_group 1 "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]" AN_subtabs 1 "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]"
		
		#PART-I :  State Transition Diagram	within a tab		
			dict set MAIN_DICT var.SEQstates_perAN[set j] [dict get $MAIN_DICT KR_states_seq.[lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]]
			
			#Create a group (within a tab) for displaying sequence of SEQUENCER STATE MACHINE
			widget_group 1 "ANgroup1$j" "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]" [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]] "[lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]"			
			
		
			#Display all STATES in a sequence (in form of disabled buttons0). Buttons can be displayed as GREEN or RED based on if a certain state PASSED or FAILED. Condition for PASS or FAIL is contaoned in the below IF condition. 	
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr i}	{
				if { [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].display] == 1 } {
				#puts [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].display]
				
				if {[regexp "SSM_AN_CHK" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i]] match] && [dict get $MAIN_DICT an_done.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].stopSample]]==0} {
					dict set MAIN_DICT var.seq_state_color red 
				} else {
					dict set MAIN_DICT var.seq_state_color green
				}
				widget_button 1 AN[expr {$j}][expr {$i}]_button "ANgroup1$j" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i]]" false [dict get $MAIN_DICT var.seq_state_color] black 400 IDLE
			}
			}
		
			#Display START TIME of each state (in form of label)
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr i}	{
				if { [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].display] == 1 } {
				widget_label 1 AN[expr {$j}][expr {$i}]_label_start "ANgroup1$j" "Start(ms): [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].startTime]" black
				}
			}
			#Display STOP TIME of each state (in form of label)
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr i}	{
				if { [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].display] == 1 } {
				widget_label 1 AN[expr {$j}][expr {$i}]_label_stop "ANgroup1$j" "Stop(ms): [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].stopTime]" black
				}
			}
			#Display Delta TIME of each state (in form of label)
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr i}	{
				if { [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].display] == 1 } {
				widget_label 1 AN[expr {$j}][expr {$i}]_label_delta "ANgroup1$j" "Delta(ms): [format %.6f [expr {[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].stopTime] - [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].startTime]}]]" blue
				}
			}		
	
		#PART-II : Status for LOCAL and REMOTE device	
			#Create one group to accomodate two individual groups for LOCAL and REMOTE device. As there is no text assigned, this will be invisible in GUI.
			widget_group 1 "ANgroup2{$j}_outer" "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]" 2 ""
					
			#Create Local Device group
				widget_group 1 "ANgroup3{$j}_inner" "ANgroup2{$j}_outer" 1 "Local Device"
					dashboard_set_property $dash "ANgroup3{$j}_inner" preferredWidth 400
					
				widget_led 1 an_enable_led$j "ANgroup3{$j}_inner" "AN Enable" [dict get $MAIN_DICT var.AN$j.an_enable_led_color]
				widget_led 1 an_done_led$j "ANgroup3{$j}_inner" [dict get $MAIN_DICT var.AN$j.an_done_led_text] [dict get $MAIN_DICT var.AN$j.an_done_led_color]
				widget_label 1 lcl_tech_label$j "ANgroup3{$j}_inner" "Local AN Tech:" black
				widget_text 1 lcl_tech_text$j "ANgroup3{$j}_inner" false [dict get $MAIN_DICT var.AN$j.lcl_tech_text_content] 50 150	
				widget_label 1 fnl_tech_label$j "ANgroup3{$j}_inner" "[dict get $MAIN_DICT var.AN$j.fnl_tech_label_text]:" black
				widget_text 1 fnl_tech_text$j "ANgroup3{$j}_inner" false [dict get $MAIN_DICT var.AN$j.fnl_tech_text_content] 50 150
		
			#Create Remote Device group	
				widget_group 1 "ANgroup4{$j}_inner" "ANgroup2{$j}_outer" 1 "Remote Device"	
					dashboard_set_property $dash "ANgroup4{$j}_inner" preferredWidth 400
				
				widget_label 1 lp_tech_label$j "ANgroup4{$j}_inner" "[dict get $MAIN_DICT var.AN$j.lp_tech_label_text]:" black
				widget_text 1 lp_tech_text$j "ANgroup4{$j}_inner" false [dict get $MAIN_DICT var.AN$j.lp_tech_text_content]	50 150
			
		#PART-III : Display AN Communication Packets
			#Create group to display all AN communicated packets. This is outer group that includes below 2 innner griups.
			widget_group 1 "ANgroup5{$j}_outer" "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]" 1 "AN Communication Packets"	
			
			if {[dict get $MAIN_DICT toggle_true] == 1} { 
			set increment_var 10
			} else {
			set increment_var [dict get $MAIN_DICT var.AN[set j]_ackm_wd_seqno] }
			#Create group to display packets being received by local device
			widget_group 1 "ANgroup6{$j}_inner" "ANgroup5{$j}_outer" $increment_var "AN Packets Received"	
				#Below combination of BUTTON, LABEL & TEXT forms the total information being displayed for one AN packet
				widget_label 1 ackm_wd_packet "ANgroup6{$j}_inner" "AN Packets(48-bits)" black
				for {set i 1} {$i < $increment_var} {incr i} {
					widget_button 1 ackm_wd_button "ANgroup6{$j}_inner" [dict get $MAIN_DICT var.AN[set j]_ackm_wd_seq.$i] false white black 160 IDLE
				}
				widget_label 1 ackm_wd_time "ANgroup6{$j}_inner" "time(msec)" black
				for {set i 1} {$i < $increment_var} {incr i} {
					widget_label 1 ackm_wd_but "ANgroup6{$j}_inner" [dict get $MAIN_DICT var.AN[set j]_ackm_wd_seq.$i.startTime] black
				}
				widget_label 1 ackm_wd_packet_details_label "ANgroup6{$j}_inner" "Packet Details(hex)" black
				for {set i 1} {$i < $increment_var} {incr i} {
					widget_text 1 ackm_wd_packet_details_content "ANgroup6{$j}_inner" false [dict get $MAIN_DICT var.AN[set j]_ackm_wd_packet_breakout.$i] 175 150
				}
				if {[dict get $MAIN_DICT toggle_true] == 1} {
				widget_label 1 ackm_wd_packet_details_label "ANgroup6{$j}_inner" "Only few packets from the sequence displayed. Information is not accurate" red
				}
			 if {[dict get $MAIN_DICT toggle_true] == 1} { 
			set increment_var_pg 10
			} else {
			set increment_var_pg [dict get $MAIN_DICT var.AN[set j]_page_data_seqno] }
			#Create group to display packets being sent by local device	
			widget_group 1 "ANgroup7{$j}_inner" "ANgroup5{$j}_outer" $increment_var_pg "AN Packets Sent"	
				#Below combination of BUTTON, LABEL & TEXT forms the total information being displayed for one AN packet
				widget_label 1 page_data_packet "ANgroup7{$j}_inner" "AN Packets(48-bits)" black
				for {set i 1} {$i < $increment_var_pg} {incr i} {
					widget_button 1 page_data_button "ANgroup7{$j}_inner" [dict get $MAIN_DICT var.AN[set j]_page_data_seq.$i] false white black 160 IDLE
				}		
				widget_label 1 page_data_time "ANgroup7{$j}_inner" "time(msec)" black
				for {set i 1} {$i < $increment_var_pg} {incr i} {
					widget_label 1 page_data_button "ANgroup7{$j}_inner" [dict get $MAIN_DICT var.AN[set j]_page_data_seq.$i.startTime] black
				}			
				widget_label 1 page_data_packet_details_label "ANgroup7{$j}_inner" "Packet Details(hex)" black
				for {set i 1} {$i < $increment_var_pg} {incr i} {
					widget_text 1 page_data_packet_details_content "ANgroup7{$j}_inner" false [dict get $MAIN_DICT var.AN[set j]_page_data_packet_breakout.$i] 175 150
				}
				if {[dict get $MAIN_DICT toggle_true] == 1} {
				widget_label 1 ackm_wd_packet_details_label "ANgroup7{$j}_inner" "Only few packets from the sequence displayed. Information is not accurate" red
				}
		#PART-IV : Waveform displays within a tab for AN ARBITER STATE MACHINE (AN_xyCharts)
			#Create group to include all XYchart widgets being displayed
			widget_group 1 "ANgroup8{$j}_outer" "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]" 1 "AN Arbiter State Machine    (Waveform levels are: 0-1,  2-3,  4-5,  6-7,  8-9,  10-11,  12-13,  14-15, 16-17 etc)"
			
			widget_group 1 "ANgroup9{$j}_inner" "ANgroup8{$j}_outer" 1 ""
				widget_button 1 refresh_waveforms_AN$j "ANgroup9{$j}_inner" "Scale Waveforms (Y-axis)" true white black 200 refresh_AN_waveforms_S10_LL_100GBase-KR4
			
			widget_group 1 "ANgroup10{$j}_inner" "ANgroup8{$j}_outer" [llength [dict get $MAIN_DICT var.SEQstates_perAN$j]] ""	
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr i} {
				if { [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].display] == 1 } {
				widget_xyChart 1 AN[set j]_xy_Chart$i "ANgroup10{$j}_inner" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i]]" "time (msec)" "" yes 500 400 {-0.20 17.20}
					set start_sample_for_AN[set j]_xyChart$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].startSample]
					set stop_sample_for_AN[set j]_xyChart$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i].stopSample]
					#set stop_sample_for_AN[set j]_xyChart1 [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] [expr {[llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]-2}]].stopSample]
					GUI_plot_waveform_100G "AN_ARB_ENABLE" AN[set j]_xy_Chart$i 0 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "AN_ARB_TX_DIS" AN[set j]_xy_Chart$i 2 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "AN_ARB_ABL_DET" AN[set j]_xy_Chart$i 4 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "AN_ARB_ACK_DET" AN[set j]_xy_Chart$i 6 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "AN_ARB_COMP_ACK" AN[set j]_xy_Chart$i 8 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "AN_ARB_AN_GOOD" AN[set j]_xy_Chart$i 10 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "AN_ARB_NXT_PAGE" AN[set j]_xy_Chart$i 12 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "an_enable" AN[set j]_xy_Chart$i 14 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
					GUI_plot_waveform_100G "an_done" AN[set j]_xy_Chart$i 16 [set start_sample_for_AN[set j]_xyChart$i] [set stop_sample_for_AN[set j]_xyChart$i]
				if {[dict get $MAIN_DICT var.DEBUG_MODE]} {
					puts "start_sample_for_AN[set j]_xyChart$i = [set start_sample_for_AN[set j]_xyChart$i]"
					puts "stop_sample_for_AN[set j]_xyChart$i = [set stop_sample_for_AN[set j]_xyChart$i]"	
				}
			}
			}
		#Part-VI : Create a empty group at end of each tab to match the length for all tabs. By default, length of  aparticular tab is taken as the biggest length from all available tabs. This group is required because widgets, by default, anchors to the center of tab
			widget_group 1 unwanted_just_to_anchor_AN$j "AN: [lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]" 1 ""	
				dashboard_set_property $dash unwanted_just_to_anchor_AN$j preferredHeight [expr {([dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]-[dict get $MAIN_DICT count_toggle]-30)*44}]
			
	}
}



# ###################   LT   ###########################################
proc LT_datamining_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock 
	global hierarchy5_ch0 hierarchy5_ch1 hierarchy5_ch2 hierarchy5_ch3
	global hierarchy6
	
	puts "\nLT Datamining in progress..."	
	
		#Below FOR loop is for no. of LT occurences 
		for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
			dict set MAIN_DICT var.SEQstates_perLT$j [dict get $MAIN_DICT KR_states_seq.[lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]]
			
			#Below FOR loop is for no. of channels (4 for 100G)
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
			
			#Processing for LT_ENABLE. Checking the status of lt_enable at the stop sample of LT (that will most likely be SSM_RC_LT except when the STP capture started somewhere in between the LT). lt_enable can be 0 at start of SSM_RC_LT but it eventually is asserted high by the end of SSM_RC_LT. And hence end of SSM_RC_LT is considered below.
				set LT_startsample [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] 0].stopSample]
				if {[dict get $MAIN_DICT [set hierarchy5_ch$ch]lt_enable.$LT_startsample] == 1} {
					dict set MAIN_DICT var.ch$ch.LT$j.lt_enable_led_color green
				} else {
					dict set MAIN_DICT var.ch$ch.LT$j.lt_enable_led_color red
				}
				dict set MAIN_DICT var.ch$ch.LT$j.lt_enable_led_text "LT_Enable"
			
			#Processing for frame_lock 
				set new_frame_lock_value 0
				set current_frame_lock_value 0
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
					#for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] 0].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] [expr {[llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]-1}]].stopSample]} {incr i}	
						if {[dict get $MAIN_DICT [set hierarchy5_ch$ch]frame_lock.$i] == 0 && [dict get $MAIN_DICT [set hierarchy5_ch$ch]rx_trained.$i] == 0} {
							set new_frame_lock_value 0
							dict set MAIN_DICT var.ch$ch.LT$j.frame_lock_led_color "red"
							dict set MAIN_DICT var.ch$ch.LT$j.frame_lock_led_text "Frame Lock"
							set current_frame_lock_value $new_frame_lock_value
						} else {
							set new_frame_lock_value 1
							if {$new_frame_lock_value != $current_frame_lock_value} {
								set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
								set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
								set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
								set ch$ch.LT[set j]_frame_lock_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
								dict set MAIN_DICT var.ch$ch.LT$j.frame_lock_led_color green
								dict set MAIN_DICT var.ch$ch.LT$j.frame_lock_led_text "Frame Lock \[[set ch[set ch].LT[set j]_frame_lock_asserted_at] msec\]"
							}
							set current_frame_lock_value $new_frame_lock_value
						}
					}
				}
			#Processing for rx_trained
				set new_rx_trained_value 0
				set current_rx_trained_value 0
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
						if {[dict get $MAIN_DICT [set hierarchy5_ch$ch]rx_trained.$i] == 0} {
							set new_rx_trained_value 0
							dict set MAIN_DICT var.ch$ch.LT$j.rx_trained_led_color "red"
							dict set MAIN_DICT var.ch$ch.LT$j.rx_trained_led_text "RX Trained"
							set current_rx_trained_value $new_rx_trained_value
						} else {
							set new_rx_trained_value 1
							if {$new_rx_trained_value != $current_rx_trained_value} {
								set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
								set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
								set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
								set ch$ch.LT[set j]_rx_trained_led_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
								dict set MAIN_DICT var.ch$ch.LT$j.rx_trained_led_color "green"
								dict set MAIN_DICT var.ch$ch.LT$j.rx_trained_led_text  "RX Trained \[[set ch[set ch].LT[set j]_rx_trained_led_asserted_at] msec\]"
							}		
							set current_rx_trained_value $new_rx_trained_value
						}
					}	
				}
			#Processing for lcl_rx_ready
				set new_lcl_rx_ready_value 0
				set current_lcl_rx_ready_value 0
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
						if {[dict get $MAIN_DICT [set hierarchy5_ch$ch]lcl_rx_ready.$i] == 0} {
							set new_lcl_rx_ready_value 0
							dict set MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_color "red"
							dict set MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_text  "Local RX Ready"
							set current_lcl_rx_ready_value $new_lcl_rx_ready_value
						} else {
							set new_lcl_rx_ready_value 1
							if {$new_lcl_rx_ready_value != $current_lcl_rx_ready_value} {
								set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
								set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
								set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
								set ch$ch.LT[set j]_lcl_rx_ready_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
								dict set MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_color "green"
								dict set MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_text  "Local RX Ready \[[set ch[set ch].LT[set j]_lcl_rx_ready_asserted_at] msec\]"
							}
							set current_lcl_rx_ready_value $new_lcl_rx_ready_value
						}
					}	
				}	
			#Processing for rmt_rx_ready
				set new_rmt_rx_ready_value 0
				set current_rmt_rx_ready_value 0
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
						if {[dict get $MAIN_DICT [set hierarchy5_ch$ch]rmt_rx_ready.$i] == 0} {
							set new_rmt_rx_ready_value 0
							dict set MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_color "red"
							dict set MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_text  "Remote RX Ready"
							set current_rmt_rx_ready_value $new_rmt_rx_ready_value
						} else {
							set new_rmt_rx_ready_value 1
							if {$new_rmt_rx_ready_value != $current_rmt_rx_ready_value} {		
								set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
								set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
								set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
								set ch$ch.LT[set j]_rmt_rx_ready_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
								dict set MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_color "green"
								dict set MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_text  "Remote RX Ready \[[set ch[set ch].LT[set j]_rmt_rx_ready_asserted_at] msec\]"
							}
							set current_rmt_rx_ready_value $new_rmt_rx_ready_value
						}
					}	
				}
			
			#Processing for (lcl_coefh, lcl_coefl).  Commands sent by RMT
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Hold_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Init_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Preset_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Post-_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Post+_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Pre-_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Pre+_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Main-_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Main+_count 0
				
				set new_rmt_cmd_value ""
				set current_rmt_cmd_value ""
				dict set MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno 1
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
						
					#converting the csv read value to decimal. Read value by default is STRING which can be decimal or hex
					set lvalue_from_csv [scan [lindex [dict get $MAIN_DICT [set hierarchy5_ch$ch]lcl_coefl.$i] 0] %x]
					set hvalue_from_csv [scan [lindex [dict get $MAIN_DICT [set hierarchy5_ch$ch]lcl_coefh.$i] 0] %x]	
					
						if {$lvalue_from_csv == 0} {
							if {$hvalue_from_csv == 0} { 
								set new_rmt_cmd_value "Hold"
							} elseif {$hvalue_from_csv == 1} {
								set new_rmt_cmd_value "Init"
							} elseif {$hvalue_from_csv == 2} {
								set new_rmt_cmd_value "Preset"
							} else {
								set new_rmt_cmd_value "invalid (H:$hvalue_from_csv, L:$lvalue_from_csv (dec))"
							}
						} elseif {$lvalue_from_csv == 32} {
							set new_rmt_cmd_value "Post-"
						} elseif {$lvalue_from_csv == 16} {
							set new_rmt_cmd_value "Post+"
						} elseif {$lvalue_from_csv == 8} {
							set new_rmt_cmd_value "Main-"
						} elseif {$lvalue_from_csv == 4} {
							set new_rmt_cmd_value "Main+"
						} elseif {$lvalue_from_csv == 2} {
							set new_rmt_cmd_value "Pre-"
						} elseif {$lvalue_from_csv == 1} {
							set new_rmt_cmd_value "Pre+"
						} elseif {$lvalue_from_csv == 3 || $lvalue_from_csv == 12 || $lvalue_from_csv == 48} {
							set new_rmt_cmd_value "Reserve"
						} else {
							set new_rmt_cmd_value "invalid (H:$hvalue_from_csv, L:$lvalue_from_csv (dec))"
						}
						if {$new_rmt_cmd_value != $current_rmt_cmd_value} {
							dict set MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno] [dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno].$new_rmt_cmd_value
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							set lcl_coefl_start_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							dict set MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno].$new_rmt_cmd_value.startTime $lcl_coefl_start_at
							dict incr MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_[set new_rmt_cmd_value]_count
							#puts "$new_rmt_cmd_value COUNT:  [dict get $MAIN_DICT var.rmt_cmd_[set new_rmt_cmd_value]_count]"
							set current_rmt_cmd_value $new_rmt_cmd_value
							dict incr MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno
						}
					}	
				}	
			#Processing for (lcl_coef_sts). Status sent by Local
				set new_lcl_sts ""
				set current_lcl_sts ""
				dict set MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno 1
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
						
						set value_from_csv [scan [lindex [dict get $MAIN_DICT [set hierarchy5_ch$ch]lcl_coef_sts.$i] 0] %x]
						
						if {$value_from_csv == 0} {
							set new_lcl_sts "no upd"
						} elseif {$value_from_csv == 48} {
							set new_lcl_sts "Post-max"
						} elseif {$value_from_csv == 32} {
							set new_lcl_sts "Post-min"
						} elseif {$value_from_csv == 16} {
							set new_lcl_sts "Post-upd"			
						} elseif {$value_from_csv == 12} {
							set new_lcl_sts "Main-max"
						} elseif {$value_from_csv == 8} {
							set new_lcl_sts "Main-min"
						} elseif {$value_from_csv == 4} {
							set new_lcl_sts "Main-upd"
						} elseif {$value_from_csv == 3} {
							set new_lcl_sts "Pre-max"
						} elseif {$value_from_csv == 2} {
							set new_lcl_sts "Pre-min"
						} elseif {$value_from_csv == 1} {
							set new_lcl_sts "Pre-upd"
						} elseif {$value_from_csv == 21} {
							set new_lcl_sts "AllTaps-upd"
						} elseif {$value_from_csv == 63} {
							set new_lcl_sts "AllTaps-max"	
						} elseif {$value_from_csv == 29} {
							set new_lcl_sts "Main-max,Post&Pre-upd"	
						} else {
							set new_lcl_sts "invalid ($value_from_csv (dec))"
						} 
						
						if {$new_lcl_sts != $current_lcl_sts} {
							dict set MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno] [dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno].$new_lcl_sts
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							set lcl_sts_start_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							dict set MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno].$new_lcl_sts.startTime $lcl_sts_start_at
							set current_lcl_sts $new_lcl_sts
							dict incr MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno
						}
					}	
				}
			
			#Processing for (rmt_coef_updh, rmt_coef_updl). Commands sent by Local.	
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Hold_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Init_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Preset_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Post-_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Post+_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Pre-_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Pre+_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Main-_count 0
				dict set MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Main+_count 0
		 
				set current_rmt_cmd_new ""
				set new_rmt_cmd_new ""
				set new_lcl_cmd_value ""
				set current_lcl_cmd_value ""
				dict set MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno 1
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i}	{
						
						set new_rmt_cmd_new [dict get $MAIN_DICT [set hierarchy6]rmt_upd_new.$i]
						if {$current_rmt_cmd_new != $new_rmt_cmd_new} {
							if {$new_rmt_cmd_new == 1} {
							
								set lvalue_from_csv [scan [lindex [dict get $MAIN_DICT [set hierarchy5_ch$ch]rmt_coef_updl.$i] 0] %x]
								set hvalue_from_csv [scan [lindex [dict get $MAIN_DICT [set hierarchy5_ch$ch]rmt_coef_updh.$i] 0] %x]
							
								if {$lvalue_from_csv == 0} {
									if {$hvalue_from_csv == 0} { 
										set new_lcl_cmd_value "Hold"
									} elseif {$hvalue_from_csv == 1} {
										set new_lcl_cmd_value "Init"
									} elseif {$hvalue_from_csv == 2} {
										set new_lcl_cmd_value "Preset"
									} 	
								} elseif {$lvalue_from_csv == 32} {
									set new_lcl_cmd_value "Post-"
								} elseif {$lvalue_from_csv == 16} {
									set new_lcl_cmd_value "Post+"
								} elseif {$lvalue_from_csv == 8} {
									set new_lcl_cmd_value "Main-"
								} elseif {$lvalue_from_csv == 4} {
									set new_lcl_cmd_value "Main+"
								} elseif {$lvalue_from_csv == 2} {
									set new_lcl_cmd_value "Pre-"
								} elseif {$lvalue_from_csv == 1} {
									set new_lcl_cmd_value "Pre+"
								} elseif {$lvalue_from_csv == 3 || $lvalue_from_csv == 12 || $lvalue_from_csv == 48} {
									set new_lcl_cmd_value "Reserve"											
								} else {
									set new_lcl_cmd_value "invalid (H:$hvalue_from_csv, L:$lvalue_from_csv (dec))"
								}
								if {$new_lcl_cmd_value != $current_lcl_cmd_value} {
									dict set MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno] [dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno].$new_lcl_cmd_value
									set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
									set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
									set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
									set lcl_coefl_start_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
									dict set MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno].$new_lcl_cmd_value.startTime $lcl_coefl_start_at
									dict incr MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_[set new_lcl_cmd_value]_count
									set current_lcl_cmd_value $new_lcl_cmd_value
									dict incr MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno
								}
							}
							set current_rmt_cmd_new $new_rmt_cmd_new		
						}
					}	
				}
			#Processing for (rmt_coef_sts). Status sent by remote 
				set new_rmt_sts ""
				set current_rmt_sts ""
				dict set MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno 1
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular LT occurence. SEQstates_perLT returns the list of SEQ state machine nos. that are part of this LT occurence.Example {11 12 13}
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perLT[set j]]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT[set j]] $k]]

					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $k].stopSample]} {incr i} {
						
						set value_from_csv [scan [lindex [dict get $MAIN_DICT [set hierarchy5_ch$ch]rmt_coef_sts.$i] 0] %x]
						
						if {$value_from_csv == 0} {
							set new_rmt_sts "no upd"
						} elseif {$value_from_csv == 48} {
							set new_rmt_sts "Post-max"
						} elseif {$value_from_csv == 32} {
							set new_rmt_sts "Post-min"
						} elseif {$value_from_csv == 16} {
							set new_rmt_sts "Post-upd"			
						} elseif {$value_from_csv == 12} {
							set new_rmt_sts "Main-max"		
						} elseif {$value_from_csv == 8} {
							set new_rmt_sts "Main-min"
						} elseif {$value_from_csv == 4} {
							set new_rmt_sts "Main-upd"
						} elseif {$value_from_csv == 3} {
							set new_rmt_sts "Pre-max"
						} elseif {$value_from_csv == 2} {
							set new_rmt_sts "Pre-min"
						} elseif {$value_from_csv == 1} {
							set new_rmt_sts "Pre-upd"
						} elseif {$value_from_csv == 21} {
							set new_rmt_sts "AllTaps-upd"	
						} elseif {$value_from_csv == 63} {
							set new_rmt_sts "AllTaps-max"	
						} elseif {$value_from_csv == 29} {
							set new_rmt_sts "Main-max,Post&Pre-upd"	
						} else {
							set new_rmt_sts "invalid ($value_from_csv (dec))"
						}
						
						if {$new_rmt_sts != $current_rmt_sts} {
							dict set MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno] [dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno].$new_rmt_sts
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							set rmt_sts_start_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							dict set MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno].$new_rmt_sts.startTime $rmt_sts_start_at
							set current_rmt_sts $new_rmt_sts
							dict incr MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno
						}
					}
				}		
		}
		puts "List of SEQ SM States per LT occurence(SEQstates_perLT$j) = [dict get $MAIN_DICT var.SEQstates_perLT$j]"
	}
	puts "LT Datamining completed"
}

proc GUI_LT_init_S10_LL_100GBase-KR4 {} {	
	global MAIN_DICT dash clock 
	global hierarchy5_ch0 hierarchy5_ch1 hierarchy5_ch2 hierarchy5_ch3
	global hierarchy6
	#Creating one tab for LT mode. It will contain sub-tabs for all LT occurences. Whatever is added to the "mytabs" will appear as a separarte tab in main tool. Here "Link Training" will be a tab
	widget_group 1 link_training_tab my_tabs 1 "Link Training"	
	
	#Creating another tabbed_group "LT_subtabs" within "Link Training". Whatever will be added directly to "LT_subtabs" will appear as a separate tab within "Link Training"
	dashboard_add $dash LT_subtabs tabbedGroup link_training_tab
		#dashboard_set_property $dash LT_subtabs preferredHeight 1300	
	
	puts ""		
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
		#Create a tab for each LT occurence
		widget_group 1 "LT: [lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]" LT_subtabs 1 "LT: [lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]"
		
		widget_label 1 LT_LFtimer_warning$j  "LT: [lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]"  "Link Training should finish with Referece Timer <= ~500msec" blue 
			
			#PART-I : State Transition Diagram within a tab						
				#Create a group (within a tab) for displaying sequence of SEQUENCER STATE MACHINE
				dict set MAIN_DICT var.SEQstates_perLT$j [dict get $MAIN_DICT KR_states_seq.[lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]]	
				
				widget_group 1 "LT[set j]group1" "LT: [lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]" [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]] "[lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]"			
				
				#Display all STATES in a sequence (in form of disabled buttons0)
				for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]} {incr i}	{
					if {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]] match] && [dict get $MAIN_DICT [set hierarchy5_ch0]rx_trained.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopSample]]==0} {
						dict set MAIN_DICT var.seq_state_color red 
					} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]] match] && [dict get $MAIN_DICT [set hierarchy5_ch1]rx_trained.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopSample]]==0} {
						dict set MAIN_DICT var.seq_state_color red 
					} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]] match] && [dict get $MAIN_DICT [set hierarchy5_ch2]rx_trained.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopSample]]==0} {
						dict set MAIN_DICT var.seq_state_color red 
					} elseif {[regexp "SSM_LT_CHK" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]] match] && [dict get $MAIN_DICT [set hierarchy5_ch3]rx_trained.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopSample]]==0} {
						dict set MAIN_DICT var.seq_state_color red 
					} else {
						dict set MAIN_DICT var.seq_state_color green
					}
					widget_button 1 LT[set j]button[set i]_button "LT[set j]group1" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]]" false [dict get $MAIN_DICT var.seq_state_color] black 500 IDLE
				}
				#Display START TIME of each state (in form of label)
				for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]} {incr i}	{
					widget_label 1 LT[set j]button[set i]_label_start "LT[set j]group1" "Start(ms): [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].startTime]" black
				}
				#Display STOP TIME of each state (in form of label)
				for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]} {incr i}	{
					widget_label 1 LT[set j]button[set i]_label_stop "LT[set j]group1" "Stop(ms): [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopTime]" black
				}
				#Display Delta TIME of each state (in form of label)
				for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]} {incr i}	{
					widget_label 1 LT[set j]button[set i]_label_delta "LT[set j]group1" "Delta(ms): [format %.6f [expr {[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopTime] - [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].startTime]}]]" blue
				}		

			dashboard_add $dash LT[set j]_channeltabs tabbedGroup "LT: [lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]"
			
			#FOR loop to create tabs for each channel	
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
			
				#Create a tab for each channel
				widget_group 1 LT[set j]_ch$ch LT[set j]_channeltabs 1 "Channel$ch"														
				
				#PART-II : Status for LOCAL and REMOTE device	
					#Create one group to accomodate two individual groups for LOCAL and REMOTE device. As there is no text assigned, this will be invisible in GUI.
					widget_group 1 "LT[set j]ch[set ch]group2_outer" LT[set j]_ch$ch 2 ""
						
					#Create Local Device group
					widget_group 1 "LT[set j]ch[set ch]group3_inner" "LT[set j]ch[set ch]group2_outer" 1 "Local Device"
						dashboard_set_property $dash "LT[set j]ch[set ch]group3_inner" preferredWidth 400
					
					widget_led 1 lt_enable_led$j "LT[set j]ch[set ch]group3_inner" [dict get $MAIN_DICT var.ch$ch.LT$j.lt_enable_led_text] [dict get $MAIN_DICT var.ch$ch.LT$j.lt_enable_led_color]
					widget_led 1 frame_lock_led "LT[set j]ch[set ch]group3_inner" [dict get $MAIN_DICT var.ch$ch.LT$j.frame_lock_led_text] [dict get $MAIN_DICT var.ch$ch.LT$j.frame_lock_led_color]
					widget_led 1 rx_trained_led "LT[set j]ch[set ch]group3_inner" [dict get $MAIN_DICT var.ch$ch.LT$j.rx_trained_led_text] [dict get $MAIN_DICT var.ch$ch.LT$j.rx_trained_led_color]
					widget_led 1 lcl_rx_ready_led "LT[set j]ch[set ch]group3_inner" [dict get $MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_text] [dict get $MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_color]		
						
					widget_label 1 lt_cmd "LT[set j]ch[set ch]group3_inner" "LT commands sent (total counts):" black
					widget_label 1 lt_cmd_init "LT[set j]ch[set ch]group3_inner" "   Init: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Init_count]" black	
					widget_label 1 lt_cmd_preset "LT[set j]ch[set ch]group3_inner" "   Preset: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Preset_count]" black	
					widget_label 1 lt_cmd_incr_vod "LT[set j]ch[set ch]group3_inner" "   Main Incr: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Main+_count]" black		
					widget_label 1 lt_cmd_dec_vod "LT[set j]ch[set ch]group3_inner" "   Main Dec: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Main-_count]" black
					widget_label 1 lt_cmd_incr_post "LT[set j]ch[set ch]group3_inner" "   Post-Tap Incr: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Post+_count]" black	
					widget_label 1 lt_cmd_dec_post "LT[set j]ch[set ch]group3_inner" "   Post-Tap Dec: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Post-_count]" black
					widget_label 1 lt_cmd_incr_pre "LT[set j]ch[set ch]group3_inner" "   Pre-Tap Incr: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Pre+_count]" black	
					widget_label 1 lt_cmd_dec_pre "LT[set j]ch[set ch]group3_inner" "   Pre-Tap Dec: [dict get $MAIN_DICT var.ch$ch.LT[set j].lcl_cmd_Pre-_count]" black	

						
					#Create Remote Device group		
					widget_group 1 "LT[set j]ch[set ch]group4_inner" "LT[set j]ch[set ch]group2_outer" 1 "Remote Device"	
						dashboard_set_property $dash "LT[set j]ch[set ch]group4_inner" preferredWidth 400
						
					widget_led 1 rmt_rx_ready_led "LT[set j]ch[set ch]group4_inner" [dict get $MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_text] [dict get $MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_color]	
					widget_label 1 rmt_lt_cmd "LT[set j]ch[set ch]group4_inner" "LT commands sent (total counts):" black	
					widget_label 1 rmt_lt_cmd_init "LT[set j]ch[set ch]group4_inner" "   Init: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Init_count]" black
					widget_label 1 rmt_lt_cmd_preset "LT[set j]ch[set ch]group4_inner" "   Preset: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Preset_count]" black
					widget_label 1 rmt_lt_cmd_inrc_vod "LT[set j]ch[set ch]group4_inner" "   Main Incr: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Main+_count]" black			
					widget_label 1 rmt_lt_cmd_dec_vod "LT[set j]ch[set ch]group4_inner" "   Main Dec: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Main-_count]" black	
					widget_label 1 rmt_lt_cmd_inrc_post "LT[set j]ch[set ch]group4_inner" "   Post-Tap Incr: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Post+_count]" black	
					widget_label 1 rmt_lt_cmd_dec_post "LT[set j]ch[set ch]group4_inner" "   Post-Tap Dec: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Post-_count]" black	
					widget_label 1 rmt_lt_cmd_incr_pre "LT[set j]ch[set ch]group4_inner" "   Pre-Tap Incr: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Pre+_count]" black		
					widget_label 1 rmt_lt_cmd_dec_pre "LT[set j]ch[set ch]group4_inner" "   Pre-Tap Dec: [dict get $MAIN_DICT var.ch$ch.LT[set j].rmt_cmd_Pre-_count]" black	
				
				#Part-III : Waveform displays within a tab for LT status signals (LT_xyCharts)
					widget_group 1 "LT[set j]ch[set ch]group5_outer" LT[set j]_ch$ch 1 "Link Training Status Signals    (Waveform levels are: 0-1,  2-3,  4-5,  6-7 etc)"
					
					widget_group 1 "LT[set j]ch[set ch]group6_inner" "LT[set j]ch[set ch]group5_outer" 1 ""
						widget_button 1 refresh_waveforms_LT[set j]ch[set ch] "LT[set j]ch[set ch]group6_inner" "Scale Waveforms (Y-axis)" true white black 200 refresh_LT_waveforms_S10_LL_100GBase-KR4
			
					widget_group 1 "LT[set j]ch[set ch]group7_inner" "LT[set j]ch[set ch]group5_outer" [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]] ""	
					
					for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]} {incr i} {	
						widget_xyChart 1 ch$ch.LT[set j]_xyChart$i "LT[set j]ch[set ch]group7_inner" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]]" "time (msec)" "" yes 500 500 {-0.20 7.20}
						
						set start_sample_for_LT[set j]_xyChart$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].startSample]
						set stop_sample_for_LT[set j]_xyChart$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i].stopSample]
						GUI_plot_waveform_100G "[set hierarchy5_ch$ch]frame_lock" ch$ch.LT[set j]_xyChart$i 0 [set start_sample_for_LT[set j]_xyChart$i] [set stop_sample_for_LT[set j]_xyChart$i]
						GUI_plot_waveform_100G "[set hierarchy5_ch$ch]rx_trained" ch$ch.LT[set j]_xyChart$i 2 [set start_sample_for_LT[set j]_xyChart$i] [set stop_sample_for_LT[set j]_xyChart$i]
						GUI_plot_waveform_100G "[set hierarchy5_ch$ch]lcl_rx_ready" ch$ch.LT[set j]_xyChart$i 4 [set start_sample_for_LT[set j]_xyChart$i] [set stop_sample_for_LT[set j]_xyChart$i]
						GUI_plot_waveform_100G "[set hierarchy5_ch$ch]rmt_rx_ready" ch$ch.LT[set j]_xyChart$i 6 [set start_sample_for_LT[set j]_xyChart$i] [set stop_sample_for_LT[set j]_xyChart$i]
						
						if {[dict get $MAIN_DICT var.DEBUG_MODE]} {
							puts "start_sample_for_LT[set j]_xyChart$i = [set start_sample_for_LT[set j]_xyChart$i]"
							puts "stop_sample_for_LT[set j]_xyChart$i = [set stop_sample_for_LT[set j]_xyChart$i]"
						}
					}		
				
				#Part-IV : Plot LT Communication packets
					widget_checkBox 1 LT[set j]_ch[set ch]_comm_packets LT[set j]_ch$ch "LT Communication Packets" GUI_LT_packet_exchange_S10_LL_100GBase-KR4
					dict set MAIN_DICT var.LT[set j]_ch[set ch]_comm_packets_plotted 0
					
				#Part-V : Create a empty group at end of each tab to match the length for all tabs. By default, length of  aparticular tab is taken as the biggest length from all available tabs. This group is required because widgets, by default, anchors to the center of tab
					widget_group 1 unwanted_just_to_anchor_LT[set j]_ch[set ch] LT[set j]_ch$ch 1 ""	
						dashboard_set_property $dash unwanted_just_to_anchor_LT[set j]_ch[set ch] preferredHeight 400		
			}	
			#Part-VI : Create a empty group at end of each tab to match the length for all tabs. By default, length of  aparticular tab is taken as the biggest length from all available tabs. This group is required because widgets, by default, anchors to the center of tab
				widget_group 1 unwanted_just_to_anchor_LT1$j "LT: [lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]" 1 ""	
					dashboard_set_property $dash unwanted_just_to_anchor_LT1$j preferredHeight [expr {([dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]-[dict get $MAIN_DICT count_toggle]-30)*44}]	
	}
}

proc GUI_LT_packet_exchange_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock
	
	widget_button 0 processing_status board_connection "Processing... Please Wait" false yellow black 100 IDLE
	
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{	
		
		for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
	
			if {![dashboard_get_property $dash LT[set j]_ch[set ch]_comm_packets checked] && ([dict get $MAIN_DICT var.LT[set j]_ch[set ch]_comm_packets_plotted] == 1)} {
				dashboard_set_property $dash "LT[set j]ch[set ch]group6_outer" visible false
				dashboard_set_property $dash unwanted_just_to_anchor_LT[set j]_ch[set ch] visible true
			} elseif {[dashboard_get_property $dash LT[set j]_ch[set ch]_comm_packets checked] && ([dict get $MAIN_DICT var.LT[set j]_ch[set ch]_comm_packets_plotted] == 1)} { 
				dashboard_set_property $dash "LT[set j]ch[set ch]group6_outer" visible true
				dashboard_set_property $dash unwanted_just_to_anchor_LT[set j]_ch[set ch] visible false
			} elseif {[dashboard_get_property $dash LT[set j]_ch[set ch]_comm_packets checked] && ([dict get $MAIN_DICT var.LT[set j]_ch[set ch]_comm_packets_plotted] == 0)} { 		
				
				dashboard_set_property $dash unwanted_just_to_anchor_LT[set j]_ch[set ch] visible false
				
				#LT Training Sequence	
					widget_group 1 "LT[set j]ch[set ch]group6_outer" LT[set j]_ch$ch 1 "LT Training Sequence"
				
					#Remote Command (Commands sent by LP)
						widget_group 1 "LT[set j]ch[set ch]group7_inner" "LT[set j]ch[set ch]group6_outer" [dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno] "Commands sent by Remote Device"									
						widget_label 1 RMT_CMD "LT[set j]ch[set ch]group7_inner" "CMD" black 
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno] - 1}]} {incr i} {
								widget_button 1 RMT_CMD$i "LT[set j]ch[set ch]group7_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.$i] false white white  100 IDLE
								if {[dict get $MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.$i] != "$i.Hold"} {
									widget_button 0 RMT_CMD$i "LT[set j]ch[set ch]group7_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.$i] false white black 100 IDLE	
								}
							}
						widget_label 1 RMT_CMD_time "LT[set j]ch[set ch]group7_inner" "time(msec)" black
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno] - 1}]} {incr i} {
								widget_label 1 RMT_CMD_time$i "LT[set j]ch[set ch]group7_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.[dict get $MAIN_DICT ch$ch.LT[set j]_rmtCMD_seq.$i].startTime] black
							}						
						#puts "ch[set ch]_LT[set j]_rmtCMD_seqno: [dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtCMD_seqno]"
					
					#Local Status (Status sent by local)				
						widget_group 1 "LT[set j]ch[set ch]group8_inner" "LT[set j]ch[set ch]group6_outer" [dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno] "Status to Remote Device"
						widget_label 1 LCL_STS "LT[set j]ch[set ch]group8_inner" "Status" black
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno]- 1}]} {incr i} {
								widget_button 1 LCL_STS$i "LT[set j]ch[set ch]group8_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.$i] false white white 100 IDLE
								if {[dict get $MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.$i] != "$i.no upd"} {
									widget_button 0 LCL_STS$i "LT[set j]ch[set ch]group8_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.$i] false white black 100 IDLE
								}
							}		
						widget_label 1 LCL_STS_time "LT[set j]ch[set ch]group8_inner" "time(msec)" black
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno] - 1}]} {incr i} {
								widget_label 1 LCL_STS_time$i "LT[set j]ch[set ch]group8_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.[dict get $MAIN_DICT ch$ch.LT[set j]_lclSTS_seq.$i].startTime] black
							}
						#puts "ch[set ch]_LT[set j]_lclSTS_seqno: [dict get $MAIN_DICT var.ch$ch.LT[set j]_lclSTS_seqno]"			
				
					#Local Command (Commands sent by local)
						widget_group 1 "LT[set j]ch[set ch]group9_inner" "LT[set j]ch[set ch]group6_outer" [dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno] "Commands sent by Local Device"
						widget_label 1 LCL_CMD "LT[set j]ch[set ch]group9_inner" "CMD" black
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno] - 1}]} {incr i} {
								widget_button 1 LCL_CMD$i "LT[set j]ch[set ch]group9_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.$i] false white white 100 IDLE
								if {[dict get $MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.$i] != "$i.Hold"} {
									widget_button 0 LCL_CMD$i "LT[set j]ch[set ch]group9_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.$i] false white black 100 IDLE
								}
							}	
						widget_label 1 LCL_CMD_time "LT[set j]ch[set ch]group9_inner" "time(msec)" black
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno] - 1}]} {incr i} {
								widget_label 1 LCL_CMD_time$i "LT[set j]ch[set ch]group9_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.[dict get $MAIN_DICT ch$ch.LT[set j]_lclCMD_seq.$i].startTime] black
							}
						#puts "ch[set ch]_LT[set j]_lclCMD_seqno: [dict get $MAIN_DICT var.ch$ch.LT[set j]_lclCMD_seqno]"
							
					#Remote Status (Status sent by Remote)
						widget_group 1 "LT[set j]ch[set ch]group10_inner" "LT[set j]ch[set ch]group6_outer" [dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno] "Status to Local Device"
						widget_label 1 RMT_STS "LT[set j]ch[set ch]group10_inner" "Status" black		
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno] - 1}]} {incr i} {
								widget_button 1 RMT_STS$i "LT[set j]ch[set ch]group10_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.$i] false white white 100 IDLE
								if {[dict get $MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.$i] != "$i.no upd"} {
									widget_button 0 RMT_STS$i "LT[set j]ch[set ch]group10_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.$i] false white black 100 IDLE
								}
							}	
						widget_label 1 RMT_STS_time "LT[set j]ch[set ch]group10_inner" "time(msec)" black
							for {set i 1} {$i <= [expr {[dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno] - 1}]} {incr i} {
								widget_label 1 RMT_STS_time$i "LT[set j]ch[set ch]group10_inner" [dict get $MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.[dict get $MAIN_DICT ch$ch.LT[set j]_rmtSTS_seq.$i].startTime] black
							}
						#puts "ch[set ch]_LT[set j]_rmtSTS_seqno: [dict get $MAIN_DICT var.ch$ch.LT[set j]_rmtSTS_seqno]"
					
					dict set MAIN_DICT var.LT[set j]_ch[set ch]_comm_packets_plotted 1
					
					
			}
		}
	}	
	widget_button 0 processing_status board_connection "Processing DONE" false green black 100 IDLE
}



# ###################   DATA   ###########################################
proc DATA_mining_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock
	
	puts "\nDATAmining in progress..."
	#Below FOR loop is for no. of DATA MODE occurences 
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
		dict set MAIN_DICT var.SEQstates_perDATA$j [dict get $MAIN_DICT KR_states_seq.[lindex [dict get $MAIN_DICT var.Data_occurence] $j]]

		#Processing for PCS Align Locked 
			set new_rpcs_align_locked_value 0
			set current_rpcs_align_locked_value 0
			
			dict set MAIN_DICT var.DATA$j.rpcs_align_locked_led_color red
			dict set MAIN_DICT var.DATA$j.rpcs_align_locked_led_text "PCS Align Lock"
			
			#Below FOR loop is for no. of SEQUENCER SM STATES in a particular DATA MODE occurence
			for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr k} {	
				set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k]]

				#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
				for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k].stopSample]} {incr i}	{
					if {[dict get $MAIN_DICT align_locked.$i] == 0} {
						set new_rpcs_align_locked_value 0
						dict set MAIN_DICT var.DATA$j.rpcs_align_locked_led_color red
						dict set MAIN_DICT var.DATA$j.rpcs_align_locked_led_text "PCS Align Lock"
						set current_rpcs_align_locked_value $new_rpcs_align_locked_value
					} else {
						set new_rpcs_align_locked_value 1
						if {$new_rpcs_align_locked_value != $current_rpcs_align_locked_value} {
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							set DATA[set j]_rpcs_align_locked_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							dict set MAIN_DICT var.DATA$j.rpcs_align_locked_led_color green
							dict set MAIN_DICT var.DATA$j.rpcs_align_locked_led_text "PCS Align Locked \[[set DATA[set j]_rpcs_align_locked_asserted_at] msec ($current_seq_state)\]"
						}
						set current_rpcs_align_locked_value $new_rpcs_align_locked_value
					}
				}
			}

		#Processing for PCS Deskew Locked 
			set new_rpcs_deskew_locked_value 0
			set current_rpcs_deskew_locked_value 0
			
			dict set MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_color red
			dict set MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_text "PCS deskew Lock"
			
			#Below FOR loop is for no. of SEQUENCERDisplay AN Communication Packets SM STATES in a particular DATA MODE occurence
			for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr k} {	
				set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k]]

				#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
				for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k].stopSample]} {incr i}	{
					if {[dict get $MAIN_DICT deskew_locked.$i] == 0} {
						set new_rpcs_deskew_locked_value 0
						dict set MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_color red
						dict set MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_text "PCS deskew Lock"
						set current_rpcs_deskew_locked_value $new_rpcs_deskew_locked_value
					} else {
						set new_rpcs_deskew_locked_value 1
						if {$new_rpcs_deskew_locked_value != $current_rpcs_deskew_locked_value} {
							set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
							set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
							set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
							set DATA[set j]_rpcs_deskew_locked_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
							dict set MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_color green
							dict set MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_text "PCS Deskew Locked \[[set DATA[set j]_rpcs_deskew_locked_asserted_at] msec ($current_seq_state)\]"
						}
						set current_rpcs_deskew_locked_value $new_rpcs_deskew_locked_value
					}
				}
			}

		#FEC Status
			set DATA_startsample [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA[set j]] 0].startSample]
			dict set MAIN_DICT var.AN$j.FECstatus [lindex [dict get $MAIN_DICT pcs_mode_rc.[expr {$DATA_startsample}]] 0]
				if {[dict get $MAIN_DICT var.AN$j.FECstatus] == 4} {
					dict set MAIN_DICT var.DATA[set j].FEC_led_color red
					dict set MAIN_DICT var.DATA[set j].FEC_led_text "FEC is OFF"
				} elseif {[dict get $MAIN_DICT var.AN$j.FECstatus] == 20} {
					dict set MAIN_DICT var.DATA[set j].FEC_led_color green
					dict set MAIN_DICT var.DATA[set j].FEC_led_text "FEC is ON"							
				} else {
					dict set MAIN_DICT var.DATA[set j].FEC_led_color red
					dict set MAIN_DICT var.DATA[set j].FEC_led_text "FEC has value: [dict get $MAIN_DICT var.AN$j.FECstatus]"
				}
	
		#Processing for rpcs_word_locked
			set new_rpcs_word_locked_value 0
			set current_rpcs_word_locked_value 0
			
			dict set MAIN_DICT var.DATA$j.rpcs_word_locked_led_text "-- msec"
			dict set MAIN_DICT var.DATA$j.rpcs_word_locked_led_color "red"
			
			
				#Below FOR loop is for no. of SEQUENCER SM STATES in a particular DATA MODE occurence
				for {set k 0} {$k < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr k} {	
					set current_seq_state [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k]]
					
					#Below FOR loop is for no. of samples in a particular STATE of Sequencer State Machine
					for {set i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k].startSample]} {$i <= [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $k].stopSample]} {incr i}	{
						if {[dict get $MAIN_DICT word_locked.$i] == 0} {
							set new_rpcs_word_locked_value 0
							dict set MAIN_DICT var.DATA$j.rpcs_word_locked_led_color red
							dict set MAIN_DICT var.DATA$j.rpcs_word_locked_led_text "-- msec"
							set current_rpcs_word_locked_value $new_rpcs_word_locked_value
						} else {
							set new_rpcs_word_locked_value 1
							if {$new_rpcs_word_locked_value != $current_rpcs_word_locked_value} {
								set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
								set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
								set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
								set DATA[set j]_rpcs_word_locked_asserted_at [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
								dict set MAIN_DICT var.DATA$j.rpcs_word_locked_led_color green
								dict set MAIN_DICT var.DATA$j.rpcs_word_locked_led_text "PCS Word Locked \[[set DATA[set j]_rpcs_word_locked_asserted_at] msec ($current_seq_state)\]"
							}
							set current_rpcs_word_locked_value $new_rpcs_word_locked_value
						}
					}
				}	
		puts "List of SEQ States per DATA occurence(SEQstates_perDATA$j) = [dict get $MAIN_DICT var.SEQstates_perDATA$j]"
	}
	puts "DATAmining completed"
}

proc GUI_DATA_init_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock
	
	#Creating one tab for DATA mode. It will contain sub tabs for all DATA MODE occurences. Whatever is added to the "mytabs" will appear as a separarte tab in main tool. Here "Data Mode" will be a tab
	widget_group 1 data_mode_tab my_tabs 1 "Data Mode"	
	#Creating another tabbed_group "DATA_mode_subtabs" within "Data Mode". Whatever will be added directly to "DATA_mode_subtabs" will appear as a separate tab within "Data Mode"
	dashboard_add $dash DATA_mode_subtabs tabbedGroup data_mode_tab
		#dashboard_set_property $dash DATA_mode_subtabs preferredHeight 1300
	
	puts ""
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
		#Create a tab for each DATA occurence
		widget_group 1 "DATA: [lindex [dict get $MAIN_DICT var.Data_occurence] $j]" DATA_mode_subtabs 1 "DATA: [lindex [dict get $MAIN_DICT var.Data_occurence] $j]"
	
		#PART-I :  State Transition Diagram	within a tab
			dict set MAIN_DICT var.SEQstates_perDATA$j [dict get $MAIN_DICT KR_states_seq.[lindex [dict get $MAIN_DICT var.Data_occurence] $j]]
		
			#Create a group (within a tab) for displaying sequence of SEQUENCER STATE MACHINE
			widget_group 1 "DATAgroup1$j" "DATA: [lindex [dict get $MAIN_DICT var.Data_occurence] $j]" [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]] "[lindex [dict get $MAIN_DICT var.Data_occurence] $j]"

			#Display all STATES in a sequence (in form of disabled buttons). Buttons can be displayed as GREEN or RED based on if a certain state PASSED or FAILED. Condition for PASS or FAIL is contaoned in the below IF condition. 	
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i}	{
				if {[regexp "SSM_LNK_RDY" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] match] && [dict get $MAIN_DICT align_locked.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopSample]]==0} {
					dict set MAIN_DICT var.seq_state_color red 
				} elseif {[regexp "SSM_LNK_CHK" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] match] && [dict get $MAIN_DICT deskew_locked.[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopSample]]==0} {
					dict set MAIN_DICT var.seq_state_color red
				} else {
					dict set MAIN_DICT var.seq_state_color green
				}
				widget_button 1 DATA[expr {$j}][expr {$i}]_button "DATAgroup1$j" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]]" false [dict get $MAIN_DICT var.seq_state_color] black 400 IDLE
			}
			#Display START TIME of each state (in form of label)
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i}	{
				widget_label 1 DATA[expr {$j}][expr {$i}]_label_start "DATAgroup1$j" "Start(ms): [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].startTime]" black
			}
			#Display STOP TIME of each state (in form of label)
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i}	{
				widget_label 1 DATA[expr {$j}][expr {$i}]_label_stop "DATAgroup1$j" "Stop(ms): [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopTime]" black
			}
			#Display Delta TIME of each state (in form of label)
			for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i}	{
				widget_label 1 DATA[expr {$j}][expr {$i}]_label_delta "DATAgroup1$j" "Delta(ms): [format %.6f [expr {[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopTime] - [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].startTime]}]]" blue
			}			
		
		#PART-II : Status LEDs within a tab
			#Create a group for status LEDs
			widget_group 1 "DATAgroup2$j" "DATA: [lindex [dict get $MAIN_DICT var.Data_occurence] $j]" 1 "Local Device Status"			
			
			#Create STATUS LEDs
			
			widget_led 1 rpcs_align_locked_led "DATAgroup2$j" [dict get $MAIN_DICT var.DATA$j.rpcs_align_locked_led_text] [dict get $MAIN_DICT var.DATA$j.rpcs_align_locked_led_color]
			widget_led 1 rpcs_deskew_locked_led "DATAgroup2$j" [dict get $MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_text] [dict get $MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_color]
			widget_led 1 rpcs_word_locked_led   "DATAgroup2$j" [dict get $MAIN_DICT var.DATA$j.rpcs_word_locked_led_text] [dict get $MAIN_DICT var.DATA$j.rpcs_word_locked_led_color]
			widget_led 1 fec_led "DATAgroup2$j" [dict get $MAIN_DICT var.DATA$j.FEC_led_text] [dict get $MAIN_DICT var.DATA$j.FEC_led_color]
			
			#widget_group 1 "DATAgroup3$j" "DATAgroup2$j" 2 ""
				#widget_label 1 rpcs_word_locked_label "DATAgroup2$j" "PCS Word Lock" black
				
				
		
			dashboard_add $dash DATA[set j]_channeltabs tabbedGroup "DATA: [lindex [dict get $MAIN_DICT var.Data_occurence] $j]"
			
			#Add subtabs for no. of channels	
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
			
				#Create a tab for each channel
				widget_group 1 DATA[set j]_ch[set ch]_tab  DATA[set j]_channeltabs  1  "Channel$ch"		
		
				#PART-III : Waveform displays within a tab for DATA mode status signals (DATA_xyCharts)
							#Create a group for waveforms display
							widget_group 1 "DATA[set j]ch[set ch]DATAgroup4_outer"  DATA[set j]_ch[set ch]_tab  1 "DATA Mode Status Signals    (Waveform levels are: 0-1,  2-3,  4-5,  6-7,  8-9 etc)"
							
							widget_group 1 "DATA[set j]ch[set ch]DATAgroup5_inner" "DATA[set j]ch[set ch]DATAgroup4_outer" 1 ""
								widget_button 1 refresh_waveforms_DATA[set j]ch[set ch] "DATA[set j]ch[set ch]DATAgroup5_inner" "Scale Waveforms (Y-axis)" true white black 200 refresh_DATA_waveforms_S10_LL_100GBase-KR4
					
							widget_group 1 "DATA[set j]ch[set ch]DATAgroup6_inner" "DATA[set j]ch[set ch]DATAgroup4_outer" [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]] ""	
							
							#Create 'n' no. of waveform display widgets based on no. of SEQ states in a particular instance of DATA state of KR SM
							for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i} {		
								widget_xyChart 1 DATA[set j]_ch[set ch]_xyChart_status$i "DATA[set j]ch[set ch]DATAgroup6_inner" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] "time (msec)" "" yes 400 400 {-0.20 9.20}
								set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].startSample]
								set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopSample]
								
								#GUI_plot_waveform_100G "rx_enh_blk_lock$ch" 	DATA[set j]_ch[set ch]_xyChart_status$i  0  	 [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]
								GUI_plot_waveform_100G "word_locked"       DATA[set j]_ch[set ch]_xyChart_status$i  0   [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]
								GUI_plot_waveform_100G "deskew_locked" 	DATA[set j]_ch[set ch]_xyChart_status$i  2  	 [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]
								GUI_plot_waveform_100G "align_locked" 	DATA[set j]_ch[set ch]_xyChart_status$i  4  	 [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]
								GUI_plot_waveform_100G "rx_hi_ber" 			DATA[set j]_ch[set ch]_xyChart_status$i  6   [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]
														
								if {[dict get $MAIN_DICT var.DEBUG_MODE]} {
									puts "start_sample_for_DATA[set j]_ch[set ch]_xyChart_Status$i = [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]"
									puts "stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Status$i = [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_status$i]"
								}
							}

								
				#Part-IV : Waveform displays within a tab for DEVICE INTRINSIC SIGNALS (locktodata, locktoref, RESETS, )	
							#Create a group for waveforms display
							widget_group 1 "DATA[set j]ch[set ch]DATAgroup7_outer" DATA[set j]_ch[set ch]_tab [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]] "DEVICE INTRINSIC SIGNALS    (Waveform levels are: 0-1,  2-3, 4-5,  6-7,  8-9,  10-11,  12-13,  14-15,  16-17,  18-19 etc)"
							
							#Create 'n' no. of waveform display widgets based on no. of SEQ states in a particular instance of DATA state of KR SM
							for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i} {		
								widget_xyChart 1 DATA[set j]_ch[set ch]_xyChart_Intrinsic$i "DATA[set j]ch[set ch]DATAgroup7_outer" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] "time (msec)" "" yes 650 400 {-0.20 19.20}
								set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].startSample]
								set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopSample]
								
								GUI_plot_waveform_100G "rx_is_lockedtodata$ch" 	DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  0    [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "rx_is_lockedtoref$ch" 	DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  2  [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "tx_digitalreset$ch" 		DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  4    [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "tx_digitalreset_stat$ch" DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  6  [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "tx_analogreset$ch" 		DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  8    [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "tx_analogreset_stat$ch" 	DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  10  [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "rx_digitalreset$ch" 		DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  12    [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "rx_digitalreset_stat$ch" DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  14 [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "rx_analogreset$ch" 		DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  16   [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
								GUI_plot_waveform_100G "rx_analogreset_stat$ch"	DATA[set j]_ch[set ch]_xyChart_Intrinsic$i  18 [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]   [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]
														
								if {[dict get $MAIN_DICT var.DEBUG_MODE]} {
									puts "start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i = [set start_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]"
									puts "stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i = [set stop_sample_for_DATA[set j]_ch[set ch]_xyChart_Intrinsic$i]"
								}
							}
					}
		
				#PART-V : Waveform displays within a tab for DATA mode signals (DATA_xyCharts)
					#Create one more tab to display IMPORTANT STATUS of all 4 channels together
					widget_group 1 DATA[set j]_allchannels_tab  DATA[set j]_channeltabs  1  "All Channels"
					
					#Create a group for waveforms display
					widget_group 1 "DATA[set j]DATAgroup8_outer"  DATA[set j]_allchannels_tab  1 "DATA Mode Status Signals    (Waveform levels are: 0-1,  1.5-2.5,  3-4,  4.5-5.5,  6-7,  7.5-8.5, 9-10,  10.5-11.5,  13.5-14.5,  15-16,  16.5-17.5,  18-19,  19.5-20.5,  21-22,  22.5-23.5,  25-26, 26.5-27.5,  28-29,  29.5-30.5  etc)"
					
					widget_group 1 "DATA[set j]DATAgroup9_inner" "DATA[set j]DATAgroup8_outer" 1 ""
						widget_button 1 refresh_waveforms_DATA$j "DATA[set j]DATAgroup9_inner" "Scale Waveforms (Y-axis)" true white black 200 refresh_DATA_waveforms_S10_LL_100GBase-KR4
					
					widget_group 1 "DATA[set j]DATAgroup10_inner" "DATA[set j]DATAgroup8_outer" [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]] ""	
					
					
					#Create 'n' no. of waveform display widgets based on no. of SEQ states in a particular instance of DATA state of KR SM
					for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i} {		
						widget_xyChart 1 DATA[set j]_allchannels_xyChart_status$i "DATA[set j]DATAgroup10_inner" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] "time (msec)" "" yes 850 500 {-0.20 19.20}
						set start_sample_for_DATA[set j]_allchannels_xyChart_status$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].startSample]
						set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i].stopSample]
						
						GUI_plot_waveform_100G "tx_digitalreset_stat0"	DATA[set j]_allchannels_xyChart_status$i  0  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "rx_digitalreset_stat0"	DATA[set j]_allchannels_xyChart_status$i  1.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "tx_digitalreset_stat1"	DATA[set j]_allchannels_xyChart_status$i  3  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "rx_digitalreset_stat1"	DATA[set j]_allchannels_xyChart_status$i  4.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "tx_digitalreset_stat2"	DATA[set j]_allchannels_xyChart_status$i  6    [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "rx_digitalreset_stat2"	DATA[set j]_allchannels_xyChart_status$i  7.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "tx_digitalreset_stat3"	DATA[set j]_allchannels_xyChart_status$i  9  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "rx_digitalreset_stat3" DATA[set j]_allchannels_xyChart_status$i  10.5    [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]   [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
										
						GUI_plot_waveform_100G "word_locked" 	 DATA[set j]_allchannels_xyChart_status$i  13.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rpcs_word_locked1" 	 DATA[set j]_allchannels_xyChart_status$i  15  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rpcs_word_locked2" 	 DATA[set j]_allchannels_xyChart_status$i  16.5 [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rpcs_word_locked3" 	 DATA[set j]_allchannels_xyChart_status$i  18  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "deskew_locked" 	 DATA[set j]_allchannels_xyChart_status$i  15  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "align_locked" 	 DATA[set j]_allchannels_xyChart_status$i  16.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						GUI_plot_waveform_100G "rx_hi_ber" 			 DATA[set j]_allchannels_xyChart_status$i  18  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rx_enh_blk_lock0" 		 DATA[set j]_allchannels_xyChart_status$i  25  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rx_enh_blk_lock1"		 DATA[set j]_allchannels_xyChart_status$i  26.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rx_enh_blk_lock2"		 DATA[set j]_allchannels_xyChart_status$i  28  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						#GUI_plot_waveform_100G "rx_enh_blk_lock3"		 DATA[set j]_allchannels_xyChart_status$i  29.5  [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i] [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]
						
						if {[dict get $MAIN_DICT var.DEBUG_MODE]} {
							puts "start_sample_for_DATA[set j]_xyChart_allchannels_Status$i = [set start_sample_for_DATA[set j]_allchannels_xyChart_status$i]"
							puts "stop_sample_for_DATA[set j]_xyChart__allchannels_Status$i = [set stop_sample_for_DATA[set j]_allchannels_xyChart_status$i]"
						}
					}
				
				#Part-VI : Create a empty group at end of each tab to match the length for all tabs. By default, length of  aparticular tab is taken as the biggest length from all available tabs. This group is required because widgets, by default, anchors to the center of tab
					widget_group 1 unwanted_just_to_anchor_DATA$j "DATA: [lindex [dict get $MAIN_DICT var.Data_occurence] $j]" 1 ""	
						dashboard_set_property $dash unwanted_just_to_anchor_DATA$j preferredHeight [expr {([dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]-30)*44}]
			
			
	}
}


 
# ###################   API to plot xyCharts (Waveforms)   ###########################################
proc GUI_plot_waveform_100G {signal occurence offset start_sample_for_waveforms stop_sample_for_waveforms} {
	global MAIN_DICT dash clock

	set display_content ""
	set current_[set signal]_value [dict get $MAIN_DICT $signal.$start_sample_for_waveforms]
	set new_[set signal]_value [dict get $MAIN_DICT $signal.$start_sample_for_waveforms]
	lappend display_content $signal
	for {set i $start_sample_for_waveforms} {$i <= $stop_sample_for_waveforms} {incr i}	{
		set stage_one [scan [dict get $MAIN_DICT stage_one.[expr {$i}]] %x]
		set stage_two [scan [dict get $MAIN_DICT stage_two.[expr {$i}]] %x]
		set stage_trey [scan [dict get $MAIN_DICT stage_trey.[expr {$i}]] %x]
		set time [format %.6f [expr {[bin2dec [concat [format %.7d [dec2bin $stage_trey]][format %.10d [dec2bin $stage_two]][format %.10d [dec2bin $stage_one]]]/double($clock)]}]]
		
		set new_[set signal]_value [dict get $MAIN_DICT $signal.$i]
		if {[set new_[set signal]_value] == [set current_[set signal]_value]} {
			#puts $new_frame_lock_value
			lappend display_content [set time]
			lappend display_content [expr {[set new_[set signal]_value] + $offset}],
		} else {
			lappend display_content [set time]
			lappend display_content [expr {[set current_[set signal]_value] + $offset}],
			lappend display_content [set time]
			lappend display_content [expr {[set new_[set signal]_value] + $offset}],
		}					
		set   current_[set signal]_value   [set new_[set signal]_value]			
	}
	#dashboard_set_property $dash LT[set occurence]_time_chart series $display_content	
	dashboard_set_property $dash $occurence series $display_content
	#puts "LT[set j]_time_chart:  \n$display_content	"
}


# ###################   HELP   ###########################################
proc GUI_help_S10_LL_100GBase-KR4 {} {
global MAIN_DICT dash clock

	widget_group 1 help_tab my_tabs 1 "Help"
		#dashboard_set_property $dash help_tab preferredHeight 1300

	dict append MAIN_DICT var.Help_Message "Steps to capture STP: (Capture link bringup sequence after RESET (includes Auto-Negotiation and Link Training )"
	dict append MAIN_DICT var.Help_Message "\n	1. Clear the STP File so that it doesn't have any previous captured data"
	dict append MAIN_DICT var.Help_Message "\n	    1.1 This can be done by holding IP into RESET and then do START-STOOP on STP"
	dict append MAIN_DICT var.Help_Message "\n	2. Hold IP into RESET"
	dict append MAIN_DICT var.Help_Message "\n	3. Start STP capture"
	dict append MAIN_DICT var.Help_Message "\n	4. Release RESET"
	dict append MAIN_DICT var.Help_Message "\n	5. Wait ~2-5sec"
	dict append MAIN_DICT var.Help_Message "\n	6. Stop STP capture"	
	dict append MAIN_DICT var.Help_Message "\n\n\nRecommendations to capture most of the KR bring up sequence:"	
	dict append MAIN_DICT var.Help_Message "\n	1. Configure STP in transitional mode"
	dict append MAIN_DICT var.Help_Message "\n	2. Make sure the Bus Display Format (in .stp file) for all signal buses is set to default i.e. HEX"	
	dict append MAIN_DICT var.Help_Message "\n	3. Refer to Link_Analysis_STP_RequiredSignals_v2p0.xlsx for guidance on configuration of Signal Tap Logic Analyzer."
	#widget_text 1 help_message help_tab false "\n[dict get $MAIN_DICT var.Help_Message]" [expr {1100+([dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED])*35}] 1000
	dict append MAIN_DICT var.Help_Message "\n\n\nNote: Refer to User Guide for more help"
	
	if {[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED] > 30} {
		widget_text 1 help_message help_tab false "\n[dict get $MAIN_DICT var.Help_Message]" [expr {1400+(([dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]-[dict get $MAIN_DICT count_toggle]-30)*44)}] 1000
	} else {
		widget_text 1 help_message help_tab false "\n[dict get $MAIN_DICT var.Help_Message]" 1400 1000
	}
}

# ###################   Report Generation   ###########################################
proc generate_report_S10_LL_100GBase-KR4 {GUI} {
	global MAIN_DICT dash clock
	
	if {$GUI == 1} {
		dict set MAIN_DICT var.report_name [dashboard_get_property $dash output_csv_filename text]
	}
	
	if {![string match [dict get $MAIN_DICT var.report_name] ""]} {
		set file_ptr [open "[dict get $MAIN_DICT var.report_name].csv" "w+"]
			
		
		puts $file_ptr "Total KR Modes traversed:,[dict get $MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED]"
		puts $file_ptr "Total Sequencer SM States traversed:,[dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]"
		
		puts -nonewline $file_ptr "\nKR Mode:"
		for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{		
			puts -nonewline $file_ptr ",[dict get $MAIN_DICT states_seq.$j.KRstate]"
		}
		
		puts -nonewline $file_ptr "\nSequencer SM States:"
		for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{	
			puts -nonewline $file_ptr ",[dict get $MAIN_DICT states_seq.$j]"
		}	
		puts -nonewline $file_ptr "\nStart Time:"
		for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{			
			puts -nonewline $file_ptr ",[dict get $MAIN_DICT states_seq.$j.startTime]"	
		}
		puts -nonewline $file_ptr "\nStop Time:"
		for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{		
			puts -nonewline $file_ptr ",[dict get $MAIN_DICT states_seq.$j.stopTime]"
		}	
		puts -nonewline $file_ptr "\nDelta Time:"		
		for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j}	{	
			puts -nonewline $file_ptr ",[expr {[dict get $MAIN_DICT states_seq.$j.stopTime] - [dict get $MAIN_DICT states_seq.$j.startTime]}]"
		}
		
				
		puts $file_ptr "\n\nAuto Negotiation Mode"
			puts -nonewline $file_ptr ","
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{		
				puts -nonewline $file_ptr ",[lindex [dict get $MAIN_DICT var.Auto_Neg_occurence] $j]"
			}
			puts -nonewline $file_ptr "\n,AN Enable:"	
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
				if {[string match [dict get $MAIN_DICT var.AN$j.an_enable_led_color] "green"]} {
					puts -nonewline $file_ptr ",Yes"
				} else {
					puts -nonewline $file_ptr ",No"
				}
			}	
			puts -nonewline $file_ptr "\n,AN Done:"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
				if {[string match [dict get $MAIN_DICT var.AN$j.an_done_led_color] "green"]} {
					puts -nonewline $file_ptr ",Yes"
				} else {
					puts -nonewline $file_ptr ",No"
				}
			}
			puts -nonewline $file_ptr "\n,AN Done Time(msec):"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
				if {[string match [dict get $MAIN_DICT var.AN$j.an_done_led_color] "green"]} {
					puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.AN$j.an_done_led_text]"
				} else {
					puts -nonewline $file_ptr ",---"
				}
			}						
			puts -nonewline $file_ptr "\n,Local Technology:"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
				puts -nonewline $file_ptr ",[join [split [dict get $MAIN_DICT var.AN$j.lcl_tech_text_content] \n] " "]"
			}						
			puts -nonewline $file_ptr "\n,Remote Device Technology:"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
				puts -nonewline $file_ptr ",[join [split [dict get $MAIN_DICT var.AN$j.lp_tech_text_content] \n] " "]"
			}	
			puts -nonewline $file_ptr "\n,Final Technology:"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
				puts -nonewline $file_ptr ",[join [split [dict get $MAIN_DICT var.AN$j.fnl_tech_text_content] \n] " "]"
			}			
		
		
		
		puts $file_ptr "\n\nLink Training Mode"
				
			puts -nonewline $file_ptr ","
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{		
				puts -nonewline $file_ptr ",[lindex [dict get $MAIN_DICT var.Link_Training_occurence] $j]"
			}
				
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
				puts $file_ptr "\n,Channel $ch"
				
				puts -nonewline $file_ptr ",LT Enable:"	
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.lt_enable_led_color] "green"]} {
						puts -nonewline $file_ptr ",Yes"
					} else {
						puts -nonewline $file_ptr ",No"
					}
				}

				puts -nonewline $file_ptr "\n,Frame Lock:"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.frame_lock_led_color] "green"]} {
						puts -nonewline $file_ptr ",Yes"
					} else {
						puts -nonewline $file_ptr ",No"
					}
				}
				puts -nonewline $file_ptr "\n,Frame Lock Time(msec):"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.frame_lock_led_color] "green"]} {
						puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.ch$ch.LT$j.frame_lock_led_text]"
					} else {
						puts -nonewline $file_ptr ",---"
					}
				}
				
				puts -nonewline $file_ptr "\n,Local RX ready:"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_color] "green"]} {
						puts -nonewline $file_ptr ",Yes"
					} else {
						puts -nonewline $file_ptr ",No"
					}
				}
				puts -nonewline $file_ptr "\n,Local RX ready Time(msec):"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_color] "green"]} {
						puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.ch$ch.LT$j.lcl_rx_ready_led_text]"
					} else {
						puts -nonewline $file_ptr ",---"
					}
				}
				puts -nonewline $file_ptr "\n,Remote RX ready:"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_color] "green"]} {
						puts -nonewline $file_ptr ",Yes"
					} else {
						puts -nonewline $file_ptr ",No"
					}
				}
				puts -nonewline $file_ptr "\n,Remote RX ready Time(msec):"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_color] "green"]} {
						puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.ch$ch.LT$j.rmt_rx_ready_led_text]"
					} else {
						puts -nonewline $file_ptr ",---"
					}
				}	
				puts $file_ptr ""				
			}
			
		puts $file_ptr "\n\nData Mode"
			
			puts -nonewline $file_ptr ","
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{		
				puts -nonewline $file_ptr ",[lindex [dict get $MAIN_DICT var.Data_occurence] $j]"
			}
			
			puts $file_ptr "\n,All Channel"
			puts -nonewline $file_ptr ",FEC Used:"	
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
				if {[string match [dict get $MAIN_DICT var.DATA$j.FEC_led_color] "green"]} {
					puts -nonewline $file_ptr ",Yes"
				} else {
					puts -nonewline $file_ptr ",No"
				}
			}
			puts -nonewline $file_ptr "\n,PCS Align Locked:"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
				if {[string match [dict get $MAIN_DICT var.DATA$j.rpcs_align_locked_led_color] "green"]} {
					puts -nonewline $file_ptr ",Yes"
				} else {
					puts -nonewline $file_ptr ",No"
				}
			}
			puts -nonewline $file_ptr "\n,PCS Align Locked(msec):"
			for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
				if {[string match [dict get $MAIN_DICT var.DATA$j.rpcs_align_locked_led_color] "green"]} {
					puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.DATA$j.rpcs_align_locked_led_text]"
				} else {
					puts -nonewline $file_ptr ",---"
				}
			}		
			 puts -nonewline $file_ptr "\n,PCS Deskew Locked:"
			 for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
				 if {[string match [dict get $MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_color] "green"]} {
					 puts -nonewline $file_ptr ",Yes"
				 } else {
					 puts -nonewline $file_ptr ",No"
				 }
			 }
			 puts -nonewline $file_ptr "\n,PCS Deskew Locked(msec):"
			 for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
				 if {[string match [dict get $MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_color] "green"]} {
					 puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.DATA$j.rpcs_deskew_locked_led_text]"
				 } else {
					 puts -nonewline $file_ptr ",---"
				 }
			 }	
			
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
				
				puts $file_ptr "\n\n,Channel $ch"
				
				puts -nonewline $file_ptr ",PCS Word Locked:"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.DATA$j.rpcs_word_locked_led_color] "green"]} {
						puts -nonewline $file_ptr ",Yes"
					} else {
						puts -nonewline $file_ptr ",No"
					}
				}
				puts -nonewline $file_ptr "\n,PCS Word Locked (msec):"
				for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
					if {[string match [dict get $MAIN_DICT var.DATA$j.rpcs_word_locked_led_color] "green"]} {
						puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.DATA$j.rpcs_word_locked_led_text]"
					} else {
						puts -nonewline $file_ptr ",---"
					}
				}

				# puts -nonewline $file_ptr "\n,RX ENH Block Lock:"
				# for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
					# if {[string match [dict get $MAIN_DICT var.ch$ch.DATA$j.rx_enh_blk_lock_led_color] "green"]} {
						# puts -nonewline $file_ptr ",Yes"
					# } else {
						# puts -nonewline $file_ptr ",No"
					# }
				# }
				# puts -nonewline $file_ptr "\n,RX ENH Block Lock:"
				# for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
					# if {[string match [dict get $MAIN_DICT var.ch$ch.DATA$j.rx_enh_blk_lock_led_color] "green"]} {
						# puts -nonewline $file_ptr ",[dict get $MAIN_DICT var.ch$ch.DATA$j.rx_enh_blk_lock_led_text]"
					# } else {
						# puts -nonewline $file_ptr ",---"
					# }
				# }				
			}
					
		close $file_ptr	
		puts "********    Report Generated: [dict get $MAIN_DICT var.report_name].csv    ********"
	} else {
		puts "\n********    Output report name cannot be NULL    ********"
	}

}



# ################### Scale Waveforms (Y-axis) to scale to Y-axis
proc refresh_AN_waveforms_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Auto_Neg_occurence]]} {incr j}	{
		for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perAN[set j]]]} {incr i} {
			widget_xyChart 0 AN[set j]_xy_Chart$i "ANgroup10{$j}_inner" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perAN[set j]] $i]]" "time (msec)" "" yes 500 400 {-0.20 17.20}
		}
	}
}

proc refresh_LT_waveforms_S10_LL_100GBase-KR4 {} {	
	global MAIN_DICT dash clock
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Link_Training_occurence]]} {incr j}	{
		for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perLT$j]]} {incr i} {	
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
				widget_xyChart 0 ch$ch.LT[set j]_xyChart$i "LT[set j]ch[set ch]group7_inner" "[dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perLT$j] $i]]" "time (msec)" "" yes 500 500 {-0.20 7.20}
			}
		}	
	}
}

proc refresh_DATA_waveforms_S10_LL_100GBase-KR4 {} {
	global MAIN_DICT dash clock
	for {set j 0} {$j < [llength [dict get $MAIN_DICT var.Data_occurence]]} {incr j}	{
		for {set i 0} {$i < [llength [dict get $MAIN_DICT var.SEQstates_perDATA$j]]} {incr i} {	
			for {set ch 0} {$ch < [dict get $MAIN_DICT var.no_of_channels]} {incr ch}	{
				widget_xyChart 0 DATA[set j]_ch[set ch]_xyChart_status$i "DATA[set j]ch[set ch]DATAgroup6_inner" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] "time (msec)" "" yes 400 400 {-0.20 9.20}
			
				widget_xyChart 0 DATA[set j]_ch[set ch]_xyChart_Intrinsic$i "DATA[set j]ch[set ch]DATAgroup7_outer" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] "time (msec)" "" yes 650 400 {-0.20 19.20}
			}
			
			widget_xyChart 0 DATA[set j]_allchannels_xyChart_status$i "DATA[set j]DATAgroup10_inner" [dict get $MAIN_DICT states_seq.[lindex [dict get $MAIN_DICT var.SEQstates_perDATA$j] $i]] "time (msec)" "" yes 850 500 {-0.20 19.20}
		}
	}	
}



proc toggle_check {state1 state2 state3} {
global MAIN_DICT clock
set prev_state ""
set current_state ""
set start_toggle_zone 0
set stop_toggle_zone 0
set toggle_start 0
set toggle 0
dict set MAIN_DICT count_toggle 0
dict set MAIN_DICT toggle_true 0

	for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED]} {incr j} {
		set current_state [ lindex [split [dict get $MAIN_DICT states_seq.[expr {$j}]] "." ] 1 ]
		if {$prev_state == "$state1" && $current_state == "$state2" && $toggle_start == 0}	{
			set toggle_start 1
			if {$toggle == 0}	{ 
				set start_toggle_zone $j
			}	
			incr toggle
		} elseif {$prev_state == "$state1" && $current_state == "$state2" && $toggle_start == 1} {
			set stop_toggle_zone $j
			incr toggle
			# for {set i $start_toggle_zone } {$i <= $stop_toggle_zone} {incr i} {
				# dict set MAIN_DICT states_seq.[expr {$i}].display 0
				# puts "$toggle: [dict get $MAIN_DICT states_seq.[expr {$i}].display]"
			# }
		} elseif { $toggle_start == 1 && $prev_state == "$state2" && $current_state == "$state3" } {
			set stop_toggle_zone $j
			set toggle_start 0
			#puts $start_toggle_zone
			#puts $stop_toggle_zone
			#puts $toggle
				if {$toggle > 6} {
				  dict set MAIN_DICT toggle_true 1
				 for {set i [expr {[dict get $MAIN_DICT display_number]+$start_toggle_zone-1}]} {$i <= [expr {$stop_toggle_zone-[dict get $MAIN_DICT display_number]+2}] } {incr i} {
					dict incr MAIN_DICT count_toggle
					dict set MAIN_DICT states_seq.[expr {$i}].display 0
					}
				}
		set toggle 0
		} elseif { $toggle_start == 1 && $j == [dict get $MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED] } {
			 #puts $toggle
		     dict set MAIN_DICT toggle_true 1
			 for {set i [expr {[dict get $MAIN_DICT display_number]+$start_toggle_zone-1}]} {$i < [expr {$stop_toggle_zone-[dict get $MAIN_DICT display_number]+2}] } {incr i} {
				dict incr MAIN_DICT count_toggle
				dict set MAIN_DICT states_seq.[expr {$i}].display 0
				}
			
		}
		set prev_state [ lindex [split [dict get $MAIN_DICT states_seq.[expr {$j}]] "." ] 1 ]
	}

#puts [dict get $MAIN_DICT count_toggle]	
}

